#! /usr/bin/env python
# -*- coding: utf8 -*-

import gtk, string, gettext, shlex
import gobject
_ = gettext.gettext

from util import *
from threads import thread_func
from threads import thread_command


####################################################################################################

def send_file(cfg, user_list, file):

    if ( user_list == [] ):
	return

    thread_send_file = thread_func(cfg, True, send_file_t, cfg, user_list, file)
    thread_send_file.start()

####################################################################################################

def send_file_t(cfg, user_list, file):

    if (os.path.isfile(file) == False ):
	return False
	
    status_user = ""
    file = file.replace(" ", "\ ")
    
    for z in user_list:
	z = check_user_list(cfg, [z], "empty")
	if ( z == [] ):
	    continue
	d = {}
	for key, value in zip(cfg.z, z[0]):
	    d[key] = value

	d['folder_user'] = d['folder_user'].replace(" ", "\\ ")
    	cmd = cfg.scp+file+" "+d['user']+"@"+d['server']+"':~/"+d['folder_user']+"/'"
	proc = popen_sub(cfg, shlex.split(cmd))
	if ( proc == False ):
    	    continue
	
	# список пользователей для status
    	status_user = status_user+d['alias']+", "
	
    if ( status_user != "" ):
	cfg.status(_("Request")+" '"+_("Send file")+"' "+_("completed")+" - "+status_user[:-2])

	

####################################################################################################

def run_command(cfg, user_list, command, action=""):

    if ( user_list == [] ):
	return

    if ( action == "console_server" or  action == "console_host" ):
	thread_run_command = thread_func(cfg, False, run_command_t, cfg, user_list, command, action)
    else:
	thread_run_command = thread_func(cfg, True, run_command_t, cfg, user_list, command, action)
    thread_run_command.start()

####################################################################################################

def run_command_t(cfg, user_list, command, action=""):

    command = command.replace(" ", "\ ")
    for z in user_list:
	
    	# проверять по одному, иначе 'over Server' медленно
    	if ( action == _("Reboot") or action == _("Shutdown") ):
	    z = check_user_list(cfg, [z], "ssh")
	elif ( action == "console_server" ):
	    z = check_user_list(cfg, [z], "empty")
	elif ( action == "console_host" ):
	    z = check_user_list(cfg, [z], "ssh")
	else:
	    z = check_user_list(cfg, [z], "command")
	if ( z == [] ):
	    continue

	d = {}
	for key, value in zip(cfg.z, z[0]):
	    d[key] = value
	    
	if ( action == _("Turn On") ):
	    if ( validate("mac", d['mac'] ) == False ):
		cfg.status(_("Wrong")+" MAC "+_("address")+" "+alias+"("+mac+")")
		continue
    	    command = cfg.wol_command+mac

	elif ( action == _("Lock screen") ):
	    if ( d['desktop'] in cfg.unknown_desktop ):
		continue
	    else:
    		command = cfg.lock[d['desktop']]

	elif ( action == _("Unlock screen") ):
	    if ( d['desktop'] in cfg.unknown_desktop ):
		continue
	    else:
    		command = cfg.unlock[d['desktop']]
    	
	elif ( action == _("Logout") or action == _("Reboot") or action == _("Shutdown") ):
	    if ( d['desktop'] in cfg.unknown_desktop ):
		command = ""
    	    elif ( cfg.logoutCommandUse == "y" ):
    		command = cfg.logoutCommand
    	    else:
    		command = cfg.logout[d['desktop']]

	elif ( action == _("Send message") ):
	    if ( d['desktop'] in cfg.unknown_desktop ):
		continue
    	    else:
    		command = cfg.message_system[d['desktop']]+'"'+command+'"'

	elif ( action == "console_server" or action == "console_host" ):
	    pass
	    

    	# client
    	NX = False
    	if ( d['client'] == "nx" and cfg.vncNxHost != "y" ):
    	    NX = True

	# перезагрузка или выключение затем завершение сеанса, иначе автологин
	# Пауза...
    	if ( action == _("Reboot") or action == _("Shutdown") ):
    	    if ( d['over_server'] == "True" ):
    		# туннель для SSH
		local_port = ssh_tunnel(cfg, d['server_key'], d['server_port'], d['server_user'], d['server'], d['ip'], d['host_port'])
		if ( local_port == "0" ):
		    # не выполнять
		    NX = True
		else:
    		    ssh2 = cfg.ssh_command(d['host_key'], d['local_port'], d['host_user'], "127.0.0.1")
	    else:
    		ssh2 = cfg.ssh_command(d['host_key'], d['host_port'], d['host_user'], d['ip'])

	    if ( action == _("Reboot") and NX == False ):
		if ( cfg.ltspInfo == "ltspinfo" and d['server'] != "standalone" and d['over_server'] == "False" ):
    		    cmd2 = "ltspinfo -r -h "+d['ip']
		else:
        	    cmd2 = ssh2+" reboot &"
    		proc2 = popen_sub(cfg, cmd2.split())

	    if ( action == _("Shutdown") and NX == False ):
		if ( cfg.ltspInfo == "ltspinfo" and d['server'] != "standalone" and d['over_server'] == "False" ):
        	    cmd2 = "ltspinfo -s -h "+d['ip']
		else:
        	    cmd2 = ssh2+" halt &"
    		proc2 = popen_sub(cfg, cmd2.split())
	
	#
	if ( action == "console_server" ):
	    command = d['console_server']
    	    ssh1 = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'], " -Y -t ")
    	    cmd1 = cfg.local_console+ssh1+command
    	elif ( action == "console_host" ):
    	    command = d['console_host']
    	    ssh1 = cfg.ssh_command(d['host_key'], d['host_port'], d['host_user'], d['ip'], " -Y -t ")
    	    cmd1 = cfg.local_console+ssh1+command
	else:
    	    ssh1 = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'])
    	    cmd1 = ssh1+"export DISPLAY="+d['display']+".0;"+command

	if ( command != "" ):
	    proc1 = popen_sub(cfg, shlex.split(cmd1))
	    if ( proc1 == False ):
    		continue

	if ( action != "" and "console" not in action ):
	    cfg.status(d['user']+"@"+d['server']+"("+d['alias']+")"+" - "+_("Request")+" '"+action+"' "+_("completed"))

####################################################################################################

