#! /usr/bin/env python
# -*- coding: utf8 -*-

from __future__ import with_statement
import gtk, os, socket, string, gettext, ConfigParser
import time, datetime
import gobject
import logging
import logging.handlers as handlers
_ = gettext.gettext

from util import *

logFile = os.path.expanduser("~/.vnc/config.log")
icon_path = os.path.expanduser("icons/")
configFile = os.path.expanduser("~/.vnc/config.cfg")
cfg_defaults = {'hide_setting': 'n',
		'hide_tree_add_remove': 'n',
		'hide_tree_drag': 'n',
		'hide_viewer': 'n',
		'hide_control': 'n',
		'hide_vnc_servers': 'n',
		'hide_timer': 'n',
		'hide_command': 'n',
		'hide_client_info': 'n',
		'hide_util': 'n',
		'hide_system_util': 'n',
		'gecos_alias': 'n',
		'main_window_x': '580',
		'main_window_y': '640',
		'paned_window_x': '440',
		'tree_x': '320',
	        'vnc_nx_host': 'y',
		'vnc_nx_scan': 'y',
	        'vnc_nx_create': 'y',
		'ltspinfo': 'ssh',
	        'vnc_gtk': 'y',
	        'vnc_gtk_x': '800',
	        'vnc_gtk_y': '600',
		'alias1': ',',
		'server_list': '0',
		'group_list': '0',
		'timer_list': '0',
		'vnc_server_list': '1',
		'vnc_server': 'x11vnc -noxdamage',
		'vnc_server_ssh': 'n',
		'vnc_server1': 'Local',
		'vnc_server1_users': '0',
		'check_status': 'y',
		'check_status_interval': '10',
		'vnc_thumbnails_x': '256',
		'vnc_thumbnails_y': '204',
		'vnc_shot_folder': '~/.vnc',
		'tree_show': '0',
		'font_default': 'Arial 10',
		'font_tree': 'Arial 10',
		'font_status': 'Arial 10',
		'font_thumbnails': 'Arial 10',
		'f1': 'firefox',
		'f2': 'konqueror ~/Документы/',
		'f3': 'Приходите к нам еще',
		'f4': 'Уж лучше вы к нам',
		'logout_command_use': 'n',
		'logout_command': 'pkill -9 -u $USER'}

####################################################################################################

class cfg():
    
    def __init__(self):
	
	if (not os.path.exists(os.path.expanduser("~/.vnc"))):
	    os.makedirs(os.path.expanduser("~/.vnc"))
	
	self.logger = logging.getLogger('MyLogger')
	self.logger.setLevel(logging.DEBUG)
	handler = logFileHandler(logFile, maxBytes=100000)
	self.logger.addHandler(handler)

	self.config = ConfigParser.SafeConfigParser(cfg_defaults)
	self.config.read(configFile)
	
	#
	self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
	
	# журнал
	self.bufferStatus = gtk.TextBuffer()
	
	# Курсор
	self.cursor_wait_status = False
	
	# userList
	# Первые 10 лучше не менять местами
	self.z = [
		'alias',
		'user',
		'host',
		'ip',
		'server',
		'client',
		'start_time',
		'mac',
		'desktop',
		'group',
		    
		'host_port',
		'server_port',
		'server_user',
		'host_user',
		'dhcp',
		    
		'vnc_pass',
		'vnc_pass_file',
		'vnc_command',
		'vnc_client',
		'over_server',
		    
		'vnc_normal',
		'vnc_ssh',
		'timeout',
		'vnc_server',
		'vncport',
		    
		'server_key',
		'host_key',
		'vnc_server_ssh',
		'display',
		'uid',
		    
		'console_server',
		'console_host',
		'32',
		'folder_user',
		'34',

		'vnc_gtk_color',
		'vnc_create',
		'37',
		'38',
		'39',

		'40',
		'41',
		'42',
		'43',
		'44',

		'45',
		'46',
		'47',
		'48',
		'49'
		]
	
	self.dn = {}
        for x in range(len(self.z)):
    	    self.dn[self.z[x]] = int(x)
		    
	self.userList = gtk.TreeStore( *( [str]*50 + [gtk.gdk.Pixbuf]*10 ) )
	self.userList.set_default_sort_func(None)
    
	# тоже что и userList + 
	# user, ip, ssh_port, x11vnc_port, vnc_server_ssh,
	# ssh_key, str, (60+61+62), server_ssh_pid, client_ssh_pid,
	self.vncList = gtk.TreeStore( *( [str]*60 + [gtk.gdk.Pixbuf]*3 + [gobject.TYPE_PYOBJECT]*2 ) )

	# number,action,start,command,icon,user_list[[],[]],timer_id
	self.timersList = gtk.TreeStore(str, str, str, str, gtk.gdk.Pixbuf, gobject.TYPE_PYOBJECT, int)
    
	self.messageList = gtk.ListStore(str)

	self.mount_point = None

	self.local_console = ""
	proc = subprocess.Popen(['which', 'konsole', 'gnome-terminal'], stdin=None, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
	proc.wait()
	out = proc.stdout.read()
	if ( "konsole" in out ):
	    self.local_console = "konsole --noclose -e "
	elif ( "gnome-terminal" in out):
	    self.local_console = "gnome-terminal -x "
	else:
	    self.local_console = "xterm -e "
	
	self.local_hostname = socket.gethostname()
	self.local_ip = socket.gethostbyname(self.local_hostname)
	self.local_user = os.environ.get("USER")
	self.local_display = os.environ.get("DISPLAY")
	self.local_home = os.environ.get("HOME")

	self.localhost = [
	    'localhost',
	    '127.0.0.1',
	    self.local_ip,
	    self.local_hostname]

	self.ssh = "ssh -o StrictHostKeyChecking=no -o PasswordAuthentication=no "
	self.scp = "scp -o StrictHostKeyChecking=no -o PasswordAuthentication=no -r "
	self.sshfs = "sshfs -o StrictHostKeyChecking=no -o PasswordAuthentication=no "
	self.arp_command = "/sbin/arp -a "
	self.nmap_command= "nmap "
	self.wol_command = "wol "
	self.who_command = "who -s "
	self.ps_command = "ps "
	self.netstat_command = "netstat "
    	

	self.known_desktop = ["kde3", "kde4", "gnome2", "gnome3", "windows", "unknown"]
	self.unknown_desktop = ["windows", "unknown"]

	self.message_system = { 'kde3': 'kdialog --msgbox ',
			'kde4': 'kdialog --msgbox ',
			'gnome2': 'zenity --info --text ',
			'gnome3': 'zenity --info --text ' }

	self.lock = { 'kde3': 'dcop kdesktop KScreensaverIface lock',
		'kde4': 'qdbus org.freedesktop.ScreenSaver /ScreenSaver Lock',
		'gnome2': 'gnome-screensaver;gnome-screensaver-command -a',
		'gnome3': 'gnome-screensaver;gnome-screensaver-command -a' }

	self.unlock = { 'kde3': 'killall -s 9 -u $USER kdesktop_lock',
		'kde4': 'killall -s 9 -u $USER krunner_lock',
		'gnome2': 'killall -s 9 -u $USER gnome-screensaver',
		'gnome3': 'killall -s 9 -u $USER gnome-screensaver'}

	self.logout = { 'kde3': 'dcop ksmserver default logout 0 0 0',
		'kde4': 'qdbus org.kde.ksmserver /KSMServer logout 0 0 0',
		'gnome2': 'killall gnome-session',
		'gnome3': 'gnome-session-quit --logout --force --no-prompt' }
    
	self.phandle_size = 0
    	gtk.rc_parse_string("style 'my_style' {\n"
			    "GtkPaned::handle-size = 0\n"
                            " }\n"
                            "widget '*' style 'my_style'")

    def read(self):
	
    	self.min_mainWindowX = 580
    	self.min_mainWindowY = 640
    	self.min_panedWindowX = 440
    	self.max_panedWindowX = 640
    	self.min_treeX = 320
    	self.max_treeX = 640
	
    	self.mainWindowX = int(self.read_config("window","main_window_x"))
    	self.mainWindowY = int(self.read_config("window","main_window_y"))
    	self.window_x = self.mainWindowX
    	self.window_y = self.mainWindowY
    	self.panedWindowX = int(self.read_config("window","paned_window_x"))
    	self.treeX = int(self.read_config("window","tree_x"))

	y = get_workspace()[1]
        if ( self.mainWindowY > y ):
    	    self.mainWindowY = y
    	    if ( self.min_mainWindowY > y ):
    		self.min_mainWindowY = y
        
        self.mainWindowLastX = self.mainWindowX

	self.window.move(0,0)
	self.window.set_resizable(True)
	self.window.resize(self.mainWindowX, self.mainWindowY)
	self.window.set_size_request(self.min_mainWindowX, self.min_mainWindowY)

    	self.fontDefault = self.read_config("tree","font_default")
        gtk.settings_get_default().props.gtk_font_name = self.fontDefault
        
	##########################################
	
	self.messageList.clear()
    	for i in range(20):
    	    if ( self.read_config("command","f"+str(i+1)) != "" ):
    		self.messageList.append([self.read_config("command","f"+str(i+1))])

    	self.logoutCommandUse = self.read_config("system","logout_command_use")
    	self.logoutCommand = self.read_config("system","logout_command")

    	self.hideSetting = self.read_config("hide","hide_setting")
    	self.hideTreeAddRemove = self.read_config("hide","hide_tree_add_remove")
    	self.hideTreeDrag = self.read_config("hide","hide_tree_drag")
    	self.hideViewer = self.read_config("hide","hide_viewer")
    	self.hideControl = self.read_config("hide","hide_control")
    	self.hideVncServers = self.read_config("hide","hide_vnc_servers")
    	self.hideTimer = self.read_config("hide","hide_timer")
    	self.hideCommand = self.read_config("hide","hide_command")
    	self.hideClientInfo = self.read_config("hide","hide_client_info")
    	self.hideUtil = self.read_config("hide","hide_util")
    	self.hideSystemUtil = self.read_config("hide","hide_system_util")

    	self.vncThumbnailsX = int(self.read_config("vnc","vnc_thumbnails_x"))
    	self.vncThumbnailsY = int(self.read_config("vnc","vnc_thumbnails_y"))
    	self.vncShotFolder = self.read_config("vnc","vnc_shot_folder")
	self.vncShotFolder = os.path.expanduser(self.vncShotFolder)

    	self.vncGtk = self.read_config("vnc","vnc_gtk")
    	self.vncGtkX = int(self.read_config("vnc","vnc_gtk_x"))
    	self.vncGtkY = int(self.read_config("vnc","vnc_gtk_y"))

    	self.vncServer = self.read_config("vnc","vnc_server")
    	self.vncServerSsh = self.read_config("vnc","vnc_server_ssh")

    	self.gecosAlias = self.read_config("tree","gecos_alias")
    	self.treeShow = self.read_config("tree","tree_show")
    	self.fontTree = self.read_config("tree","font_tree")
    	self.fontStatus = self.read_config("tree","font_status")
    	self.fontThumbnails = self.read_config("tree","font_thumbnails")
    	self.checkStatus = self.read_config("tree","check_status")
    	self.checkStatusInterval = self.read_config("tree","check_status_interval")

    	self.f1 = self.read_config("command","f1")
    	self.f2 = self.read_config("command","f2")
    	self.f3 = self.read_config("command","f3")
    	self.f4 = self.read_config("command","f4")
    	self.f5 = self.read_config("command","f5")
    	self.f6 = self.read_config("command","f6")
    	self.f7 = self.read_config("command","f7")
    	self.f8 = self.read_config("command","f8")
    	self.f9 = self.read_config("command","f9")
    	self.f10 = self.read_config("command","f10")
    	self.f11 = self.read_config("command","f11")
    	self.f12 = self.read_config("command","f12")
    	self.f13 = self.read_config("command","f13")
    	self.f14 = self.read_config("command","f14")
    	self.f15 = self.read_config("command","f15")
    	self.f16 = self.read_config("command","f16")
    	self.f17 = self.read_config("command","f17")
    	self.f18 = self.read_config("command","f18")
    	self.f19 = self.read_config("command","f19")
    	self.f20 = self.read_config("command","f20")
    	
    	self.vncNxHost = self.read_config("system","vnc_nx_host")
    	self.vncNxScan = self.read_config("system","vnc_nx_scan")
    	self.vncNxCreate = self.read_config("system","vnc_nx_create")
    	self.ltspInfo = self.read_config("system","ltspinfo")
    	
    def ssh_command(self, key, port, user, ip, mode=""):
	return self.ssh+mode+" -i "+key+" -p "+port+" "+user+"@"+ip+" "
    
    def read_icons(self):
	
	# gtk icon theme
	#settings = gtk.settings_get_default()
	#settings.set_string_property("gtk-icon-theme-name", "", "")
	#self.icon_theme = gtk.icon_theme_get_default()
	#self.icon_theme.prepend_search_path(icon_path)
	#self.list_icons = self.icon_theme.list_icons()
	#self.icon_theme.load_icon(icon_name,16,0)

	self.pixbuf_list_add_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_add_16.png")
	self.pixbuf_list_remove_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_remove_16.png")
	self.pixbuf_list_transfer_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_transfer_16.png")
	self.pixbuf_list_up_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_up_16.png")
	self.pixbuf_list_edit_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_edit_16.png")
	self.pixbuf_list_clear_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_clear_16.png")
	self.pixbuf_list_play_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_play_16.png")
	self.pixbuf_list_stop_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_stop_16.png")
	self.pixbuf_list_save_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_save_16.png")
	self.pixbuf_list_file_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_16.png")
	self.pixbuf_list_link_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_link_16.png")
	self.pixbuf_list_mount_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_mount_16.png")
	self.pixbuf_list_file_hide_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_hide_16.png")
	self.pixbuf_list_folder_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_folder_16.png")
	self.pixbuf_list_file_add_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_add_16.png")
	self.pixbuf_list_folder_add_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_folder_add_16.png")
	self.pixbuf_list_file_copy_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_copy_16.png")
	self.pixbuf_list_file_paste_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_paste_16.png")
	self.pixbuf_list_file_edit_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_edit_16.png")
	self.pixbuf_list_file_remove_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_remove_16.png")
	self.pixbuf_list_file_send_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"list_file_send_16.png")

	self.pixbuf_action_close_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"action_close_16.png")

	self.pixbuf_action_send_message_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"action_send_message_16.png")
	self.pixbuf_action_run_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"action_run_16.png")

	self.pixbuf_action_refresh_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"action_refresh_16.png")
	self.pixbuf_action_refresh = gtk.gdk.pixbuf_new_from_file(icon_path+"action_refresh_32.png")

	self.pixbuf_action_viewer_16 = gtk.gdk.pixbuf_new_from_file(icon_path+'action_viewer_16.png')
	self.pixbuf_action_viewer = gtk.gdk.pixbuf_new_from_file(icon_path+"action_viewer_32.png")

	self.pixbuf_action_control_16 = gtk.gdk.pixbuf_new_from_file(icon_path+'action_control_16.png')
	self.pixbuf_action_control = gtk.gdk.pixbuf_new_from_file(icon_path+"action_control_32.png")

	self.pixbuf_action_screenshot_16 = gtk.gdk.pixbuf_new_from_file(icon_path+'action_screenshot_16.png')

	self.pixbuf_action_thumbnails = gtk.gdk.pixbuf_new_from_file(icon_path+"action_thumbnails_32.png")

	self.pixbuf_action_vnc_servers = gtk.gdk.pixbuf_new_from_file(icon_path+"action_vnc_servers_32.png")

	self.pixbuf_action_timers = gtk.gdk.pixbuf_new_from_file(icon_path+"action_timers_32.png")

	self.pixbuf_action_user_info_16 = gtk.gdk.pixbuf_new_from_file(icon_path+'action_user_info_16.png')
	self.pixbuf_action_user_info = gtk.gdk.pixbuf_new_from_file(icon_path+"action_user_info_32.png")

	self.pixbuf_st = gtk.gdk.pixbuf_new_from_file(icon_path+"st_32.png")
	self.pixbuf_server = gtk.gdk.pixbuf_new_from_file(icon_path+"server_32.png")

	self.pixbuf_menu_util = gtk.gdk.pixbuf_new_from_file(icon_path+"menu_util_32.png")
	self.pixbuf_menu_system_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"menu_system_16.png")
	self.pixbuf_menu_system = gtk.gdk.pixbuf_new_from_file(icon_path+"menu_system_32.png")

	#
	self.pixbuf_lock_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_lock_16.png")
	self.pixbuf_lock = gtk.gdk.pixbuf_new_from_file(icon_path+"system_lock_22.png")
	self.pixbuf_unlock_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_unlock_16.png")
	self.pixbuf_unlock = gtk.gdk.pixbuf_new_from_file(icon_path+"system_unlock_22.png")

	self.pixbuf_home_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_home_16.png")
	self.pixbuf_home = gtk.gdk.pixbuf_new_from_file(icon_path+"system_home_22.png")

	self.pixbuf_console_server_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_console_server_16.png")
	self.pixbuf_console_server = gtk.gdk.pixbuf_new_from_file(icon_path+"system_console_server_22.png")

	self.pixbuf_console_host_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_console_host_16.png")
	self.pixbuf_console_host = gtk.gdk.pixbuf_new_from_file(icon_path+"system_console_host_22.png")

	self.pixbuf_process_16 = gtk.gdk.pixbuf_new_from_file(icon_path+'system_process_16.png')
	self.pixbuf_process = gtk.gdk.pixbuf_new_from_file(icon_path+"system_process_22.png")
	self.pixbuf_hwinfo_16 = gtk.gdk.pixbuf_new_from_file(icon_path+'system_hwinfo_16.png')
	self.pixbuf_hwinfo = gtk.gdk.pixbuf_new_from_file(icon_path+"system_hwinfo_22.png")

	self.pixbuf_turn_on_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_turn_on_16.png")
	self.pixbuf_turn_on = gtk.gdk.pixbuf_new_from_file(icon_path+"system_turn_on_22.png")
	self.pixbuf_logout_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_logout_16.png")
	self.pixbuf_logout = gtk.gdk.pixbuf_new_from_file(icon_path+"system_logout_22.png")
	self.pixbuf_reboot_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_reboot_16.png")
	self.pixbuf_reboot = gtk.gdk.pixbuf_new_from_file(icon_path+"system_reboot_22.png")
	self.pixbuf_shutdown_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"system_shutdown_16.png")
	self.pixbuf_shutdown = gtk.gdk.pixbuf_new_from_file(icon_path+"system_shutdown_22.png")

	self.pixbuf_status_group_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_group_16.png")
	self.pixbuf_status_server_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_server_16.png")
	
	self.pixbuf_status_up_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_up_16.png")
	self.pixbuf_status_down_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_down_16.png")
	self.pixbuf_status_unknown_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_unknown_16.png")
	self.pixbuf_status_timer_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_timer_16.png")
	self.pixbuf_status_xdmcp_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_xdmcp_16.png")
	self.pixbuf_status_ssh_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_ssh_16.png")
	self.pixbuf_status_st_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_st_16.png")
	self.pixbuf_status_nx_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_nx_16.png")
	self.pixbuf_status_kde3_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_kde3_16.png")
	self.pixbuf_status_gnome2_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_gnome2_16.png")
	self.pixbuf_status_windows_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_windows_16.png")
	self.pixbuf_status_vnc_16 = gtk.gdk.pixbuf_new_from_file(icon_path+"status_vnc_16.png")

    def status(self, text):
	time = datetime.datetime.now()
	text_status = "\n"+time.strftime(" %H:%M:%S ")+text
	text_log = time.strftime("%d.%m.%y %H:%M:%S ")+text
	self.logger.debug(text_log)
	gobject.idle_add(self.status_insert, text_status)
    
    def status_insert(self, text_status):
	self.bufferStatus.insert(self.bufferStatus.get_end_iter(), text_status)
	
    def read_config(self, section, option):
	try:
	    result = self.config.get(section, option)
	except ConfigParser.NoSectionError:
	    self.write_config(section)
	except ConfigParser.NoOptionError:
	    self.write_config(section, option)
	result = self.config.get(section, option)
	return result
	
    def write_config(self, section, option=None, value=""):
	if ( option ):
	    self.config.set(section, option, value)
	else:
	    self.config.add_section(section)
	with open(configFile, 'w') as file:
	    self.config.write(file)
	    file.close()
	
    def remove_config(self, section, item=None):
	if ( item ):
	    self.config.remove_option(section, item)
	else:
	    self.config.remove_section(section)
	with open(configFile, 'w') as file:
	    self.config.write(file)
	    file.close()

    def read_log(self):
	try:
	    with open(logFile, 'r') as file:
		return file.read()
	except:
	    return ""

    def clear_log(self):
	try:
	    with open(logFile, 'w') as file:
		file.close()
	except:
	    return False

####################################################################################################

class logFileHandler(handlers.TimedRotatingFileHandler):
    def __init__(self, filename, mode='a', maxBytes=1000, backupCount=0, encoding=None, interval=1, when='h'):
	if maxBytes > 0:
    	    mode = 'a'
        handlers.TimedRotatingFileHandler.__init__(self, filename, when, interval, backupCount, encoding)
        self.maxBytes = maxBytes
    
    def shouldRollover(self, record):
	if (self.stream == None):
	    self.stream = self._open()
	if (self.maxBytes > 0):
	    msg = "%s\n" % self.format(record)
	    self.stream.seek(0, 2)
	    if self.stream.tell() + len(msg) >= self.maxBytes:
		return 1
	t = int(time.time())
	if t >= self.rolloverAt:
	    return 1
	return 0
	
####################################################################################################
