#! /usr/bin/env python
# -*- coding: utf8 -*-

import gtk, gobject, threading
import gettext
_ = gettext.gettext

####################################################################################################

# поток для комманд
class thread_command(threading.Thread):
    def __init__(self, command):
	threading.Thread.__init__(self)

	self.stopthread = threading.Event()
	self.cond = threading.Condition()
	# список комманд
	self.command = command

    def run(self):
	self.cond.acquire()
    	for line in self.command:
	    os.system(line)
    	self.cond.notify()
    	self.cond.release()

    def stop(self):
        self.stopthread.set()

####################################################################################################

# поток для функции + gobject
class thread_gfunc(threading.Thread, gobject.GObject):

    __gsignals__ = {
	"completed": ( gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE, [] ),
	"data": (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE,(gobject.TYPE_PYOBJECT,))
	}

    def __init__(self, cfg, cursor, sensitive, func, *args):
	threading.Thread.__init__(self)
	gobject.GObject.__init__(self)

	self.cond = threading.Condition()
	self.stopthread = threading.Event()
	self.func = func
	self.args = args
	self.result = 0

	self.cfg = cfg
	self.cursor = cursor
	self.sensitive = sensitive

    def run(self):

	if ( self.cursor ):
	    from util import cursor_wait
	    cursor_wait(self.cfg, True)
	if ( self.sensitive == False ):
	    self.cfg.window.set_sensitive(False)

	self.cond.acquire()
    	self.emit("data", self.run_func())
    	self.emit('completed')
    	self.cond.notify()
    	self.cond.release()

	if ( self.cursor ):
	    cursor_wait(self.cfg, False)
	if ( self.sensitive == False ):
	    self.cfg.window.set_sensitive(True)

    def run_func(self):
	self.result = self.func(*self.args)

    def get_result(self):
	self.cond.acquire()
	while self.result == 0:
	    self.cond.wait()
	    self.cond.release()
    	return self.result

    def stop(self):
        self.stopthread.set()

####################################################################################################

class _IdleObject(gobject.GObject):

    def __init__(self):
        gobject.GObject.__init__(self)

    def emit(self, *args):
        gobject.idle_add(gobject.GObject.emit,self,*args)

####################################################################################################

# поток для функции
class thread_func(threading.Thread):

    def __init__(self, cfg, cursor, func, *args):
	threading.Thread.__init__(self)

	self.cond = threading.Condition()
	self.stopthread = threading.Event()

	self.func = func
	self.args = args
	self.result = 0

	self.cfg = cfg
	self.cursor = cursor

    def run(self):
	self.cond.acquire()

	if ( self.cursor ):
	    from util import cursor_wait
	    cursor_wait(self.cfg, True)

	self.result = self.func(*self.args)

	if ( self.cursor ):
	    cursor_wait(self.cfg, False)

    	self.cond.notify()
    	self.cond.release()
    
    def get_result(self):
	self.cond.acquire()
	while self.result == 0:
	    self.cond.wait()
	    self.cond.release()
    	return self.result

    def stop(self):
        self.stopthread.set()

####################################################################################################
