#! /usr/bin/env python
# -*- coding: utf8 -*-

import gettext, gtk
import gobject, threading
import datetime, time
_ = gettext.gettext

from util import *
from command import run_command
from threads import thread_gfunc
from tree import *


####################################################################################################

class timers:

    def __init__(self, cfg, treeView):
	
	self.cfg = cfg
	self.treeView = treeView

    def start(self):
	# Проверка активности клиентов
	self.client_status_check = True
	self.thread_client_status = thread_gfunc(self.cfg, False, True, self.client_status, float(self.cfg.checkStatusInterval))
	self.thread_client_status.start()
	
	# Проверка VNC серверов
	self.vnc_server_status_check = True
	self.thread_vnc_server_status = thread_gfunc(self.cfg, False, True, self.vnc_server_status, 1)
	self.thread_vnc_server_status.start()

	# Проверка таймеров
	self.timer_status_check = True
	self.thread_timer_active = thread_gfunc(self.cfg, False, True, self.timer_active, 1)
	self.thread_timer_active.start()
	
    def stop(self):
	# Проверка активности клиентов, ping
	self.client_status_check = False
	# vnc сервера
	self.vnc_server_status_check = False
	# Проверка включенных таймеров
	self.timer_status_check = False

####################################################################################################

    def client_status(self, timeout):
	# Проверка активности клиентов
	while self.client_status_check == True:
	    status_list = []
    	    user_list = []

	    parent = -1
    	    for parents in self.cfg.userList:
    		parent += 1
		parent_iter = self.cfg.userList.get_iter(parent)
    		for x in range(self.cfg.userList.iter_n_children(parent_iter)):
    		    user = []
    		    for y in range(50):
			user.append( self.cfg.userList[(parent,x)][y] )
		    user_list.append(user)

    	    # сортировка по серверу и отправка в nmap сборками ip
    	    # timeout 100ms
    	    hosts = ""
    	    server = ""
    	    user_list.sort(key=lambda tup: tup[4])
    	    for z in user_list:
    		if ( validate("ip", z[3]) == False ):
    	    	    continue
    		if ( server != z[4] and server != "" ):
    		    for line in self.nmap(hosts):
    			status_list.append( line.strip("()\n") )
    		    hosts = ""
    		server = z[4]
		hosts = hosts+" "+z[3]
    	    for line in self.nmap(hosts):
    		status_list.append( line.strip("()\n") )

	    if ( status_list != [] ):
		i = -1
    		for parents in self.cfg.userList:
    		    i += 1
		    parent_iter = self.cfg.userList.get_iter(i)		
    		    for y in range(self.cfg.userList.iter_n_children(parent_iter)):
    			for line in status_list:
    			    up = False
    			    if ( line.find(self.cfg.userList[(i,y)][3]) != -1 ):
    				up = True
    	    			break
    			if ( up ):
    	    		    self.cfg.userList[(i,y)][50] = self.cfg.pixbuf_status_up_16
    	    		else:
    			    self.cfg.userList[(i,y)][50] = self.cfg.pixbuf_status_down_16
	    time.sleep(timeout)
	    
    def nmap(self, hosts):
	if ( hosts == "" ):
	    return []
    	from util import popen_sub
	ssh = ""
	timeout = "100"
	cmd = ssh+self.cfg.nmap_command+" -n -sP --initial-rtt-timeout="+timeout+" "+hosts
	proc = popen_sub(self.cfg, cmd.split())
	if ( proc == False ):
	    return []
	out = proc.stdout.readlines()

	clients = []
	for x in out:
	    if ( ("scan report" in x) or ("be up" in x) ):
		clients.append(x)
	return clients

####################################################################################################
	
    def timer_userList(self, command):
	if ( command == "start" ):
	    self.thread_userList = thread_gfunc(self.cfg, False, True, create_userList, self.cfg)
	    self.thread_userList.start()
	if ( command == "stop" ):
	    # Ожидание завершения
	    self.thread_userList.get_result()
	if ( command == "restart" ):
	    # Если userList не сформирован ничего не делать
	    self.thread_userList.join(0)
	    if self.thread_userList.isAlive():
		pass
	    else:
		self.timer_userList("stop")
		self.timer_userList("start")
	
####################################################################################################

    def timer_user(self, command, num=None):
	if ( command == "start" ):
	    # таймеры из timersList # [number,status,action,start,command,userlist,timer_id]
	    for timer in range(len(self.cfg.timersList)):
		#запустить один
		if( num != None and num != timer ):
		    continue
		row = (timer,)
		# уже запущен?
		if ( self.cfg.timersList[row][6] != 0 ):
		    continue
    		start = self.cfg.timersList[row][2]
    		number = self.cfg.timersList[row][0]
    		action = self.cfg.timersList[row][1]
		# не выполнять если время истекло
		time = datetime.datetime.now()
		if ( int(start.replace(':','')) < int(time.strftime("%H%M%S")) ):
		    continue
		self.cfg.timersList[row][6] = gobject.timeout_add(1000, self.timer_user_get, number)
		self.cfg.status(_("Timer")+" №"+number+" "+_("started")+" - "+action+", "+_("starting")+" "+_("in")+" "+start)

	if ( command == "stop" ):
	    for timer in range(len(self.cfg.timersList)):
		#остановить один
		if( num != None and num != timer ):
		    continue
		row = (timer,)
    		number = self.cfg.timersList[row][0]
    		timer_id = self.cfg.timersList[row][6]
    		# уже остановлен ?
    		if ( timer_id == 0 ):
    		    continue
		# Завершить
		gobject.source_remove(timer_id)
		self.cfg.timersList[row][6] = 0
		self.cfg.status(_("Timer")+" №"+number+" "+_("stopped"))
		# Убрать иконки
    		user_list = self.cfg.timersList[row][5]
		userList_column_value(self.cfg, 54, None, user_list)

    def timer_user_get(self, number):
	for x in range(len(self.cfg.timersList)):
	    if ( self.cfg.timersList[(x,)][0] == number ):
		row = (x,)
		break
    	start = self.cfg.timersList[row][2]
	time = datetime.datetime.now()
	if ( start == time.strftime("%H:%M:%S")):
    	    number = self.cfg.timersList[row][0]
    	    action = self.cfg.timersList[row][1]
    	    command = self.cfg.timersList[row][3]
    	    user_list = self.cfg.timersList[row][5]
	    run_command(self.cfg, user_list, command, action)
	    self.cfg.status(_("Timer")+" №"+number+" "+_("completed")+" - "+action)
	    self.cfg.timersList[row][6] = 0
	    # завершить таймер
	    return False
	return True

####################################################################################################

    def timer_active(self, timeout):
	while self.timer_status_check:
	    active = False
	    for timer in range(len(self.cfg.timersList)):
	        if ( self.cfg.timersList[(timer,)][6] != 0 ):
	    	    # Если есть активные таймеры
		    active = True
	    	    self.cfg.timersList[(timer,)][4] = self.cfg.pixbuf_list_play_16
		else:
	    	    self.cfg.timersList[(timer,)][4] = None

	    if ( not active ):
		# Убрать колонку
		column = self.treeView.get_column(0)
		cell = column.get_cell_renderers()[5]
		if ( cell.get_property("visible") != False ):
		    cell.set_property("visible", False)
		    # Убрать иконки
		    for x in range(len(self.cfg.userList)):
	 	    	self.cfg.userList[(x,)][54] = None
		    	parent_iter = self.cfg.userList.get_iter((x,))
		    	for y in range(self.cfg.userList.iter_n_children(parent_iter)):
	 	    	    self.cfg.userList[(x,y)][54] = None
	    else:
		# Показать колонку
		column = self.treeView.get_column(0)
		cell = column.get_cell_renderers()[5]
		if ( cell.get_property("visible") == False ):
		    cell.set_property("visible", True)
		# Клиенты
		active_timers_list = []
		for timer in range(len(self.cfg.timersList)):
		    # id таймера
		    timer_id = self.cfg.timersList[(timer,)][6]
	 	    if ( timer_id != 0 ):
	 		active_timers_list.append(timer)
	 		continue
		    # user_list список пользователей этого таймера
		    user_list = self.cfg.timersList[(timer,)][5]
		    userList_column_value(self.cfg, 54, None, user_list)

	 	for timer in active_timers_list:
		    # user_list список пользователей этого таймера
		    user_list = self.cfg.timersList[(timer,)][5]
		    userList_column_value(self.cfg, 54, self.cfg.pixbuf_status_timer_16, user_list)
	 		
	    time.sleep(timeout)

####################################################################################################

    def vnc_server_status(self, timeout):
	# Сервера и клиенты
	while self.vnc_server_status_check:
	    if ( len(self.cfg.vncList) != 0 ):

		pid = False
		for vnc_server in range(len(self.cfg.vncList)):
		    if ( self.cfg.vncList[(vnc_server,)][58] != None and self.cfg.vncList[(vnc_server,)][58] != "" ):
			# Если есть активные сервера
			pid = True
		    else:
			self.cfg.vncList[(vnc_server,)][60] = self.cfg.pixbuf_list_stop_16
			# Локальному менять иконку только если не запущен
			if ( self.cfg.vncList[(vnc_server,)][0] == "Local" ):
			    if ( self.cfg.vncServerSsh == "y" ):
				self.cfg.vncList[(vnc_server,)][54] = "True"
			    else:
				self.cfg.vncList[(vnc_server,)][54] = "False"	
		    # Добавить иконки SSH
		    if ( self.cfg.vncList[(vnc_server,)][54] == "True" ):
		        self.cfg.vncList[(vnc_server,)][61] = self.cfg.pixbuf_status_ssh_16
		    else:
		        self.cfg.vncList[(vnc_server,)][61] = None
		
		if ( not pid ):
		    # Убрать колонку
		    column = self.treeView.get_column(0)
		    cell = column.get_cell_renderers()[4]
		    if ( cell.get_property("visible") != False ):
			cell.set_property("visible", False)
			# Убрать иконки
			for x in range(len(self.cfg.userList)):
	 		    self.cfg.userList[(x,)][53] = None
			    parent_iter = self.cfg.userList.get_iter((x,))
			    for y in range(self.cfg.userList.iter_n_children(parent_iter)):
	 			self.cfg.userList[(x,y)][53] = None
		else:
		    # Показать колонку
		    column = self.treeView.get_column(0)
		    cell = column.get_cell_renderers()[4]
		    if ( cell.get_property("visible") == False ):
			cell.set_property("visible", True)
			
		    # получить список процессов
		    # процесс SSH созданный subrocess не завершается
		    # однако, значение rssize=0
		    process = []
		    command = self.cfg.ps_command+" -o pid,rssize -u "+self.cfg.local_user
		    proc = popen_sub(self.cfg, command.split())
		    if ( proc == False ):
		        continue
		    process = proc.stdout.readlines()
		
		    for vnc_server in range(len(self.cfg.vncList)):
			pid_server = False
			if ( self.cfg.vncList[(vnc_server,)][58] != None and self.cfg.vncList[(vnc_server,)][58] != "" ):
			    pid_server = self.cfg.vncList[(vnc_server,)][58]
			# Если есть PID
			if ( pid_server ):
			    disable = True
			    for x in process:
				if ( x.split()[0] == pid_server and x.split()[1] != "0" ):
				    disable = False
				    break
			
			    if ( disable ):
	    			self.vnc_server_disable(vnc_server)
	    		    else:
	    			self.vnc_server_enable(vnc_server)
	    			# проверка клиентов
	    			server_iter = self.cfg.vncList.get_iter((vnc_server,))
				for client in range(self.cfg.vncList.iter_n_children(server_iter)):
				    if ( self.cfg.vncList[(vnc_server,client)][59] != None and self.cfg.vncList[(vnc_server,client)][59] != "" ):
					disable = True
					for x in process:
					    if ( x.split()[0] == self.cfg.vncList[(vnc_server,client)][59] and x.split()[1] != "0" ):
						disable = False
						break
					if ( disable ):
					    self.vnc_client_disable(vnc_server, client)
					else:
					    self.vnc_client_enable(vnc_server, client)
			    save_vncList(self.cfg)
			else:
			    self.vnc_server_disable(vnc_server)
	    time.sleep(timeout)
		    
    def vnc_server_enable(self, vnc_server):
	# Иконка для сервера
	self.cfg.vncList[(vnc_server,)][60] = self.cfg.pixbuf_list_play_16
	# иконка в основном списке
	user = self.cfg.vncList[(vnc_server,)][1]
	server = self.cfg.vncList[(vnc_server,)][4]
	row = find_tree(self.cfg, self.cfg.userList, user, server)
	if ( row != False ):
	    self.cfg.userList[(row[0],)][53] = self.cfg.pixbuf_status_vnc_16
	    self.cfg.userList[row][53] = self.cfg.pixbuf_status_vnc_16

    def vnc_client_enable(self, vnc_server, client):
    	self.cfg.vncList[(vnc_server,client)][60] = self.cfg.pixbuf_list_play_16
	# иконка в основном списке
	user = self.cfg.vncList[(vnc_server,client)][1]
	server = self.cfg.vncList[(vnc_server,client)][4]
	row = find_tree(self.cfg, self.cfg.userList, user, server)
	if ( row != False ):
	    self.cfg.userList[row][53] = self.cfg.pixbuf_status_vnc_16
	
    def vnc_server_disable(self, vnc_server):
	# убрать порт, pid, иконки
	self.cfg.vncList[(vnc_server,)][53] = None
	self.cfg.vncList[(vnc_server,)][58] = None
	# иконка в основном списке
	user = self.cfg.vncList[(vnc_server,)][1]
	server = self.cfg.vncList[(vnc_server,)][4]
	row = find_tree(self.cfg, self.cfg.userList, user, server)
	if ( row != False ):
	    self.cfg.userList[row][53] = None
	    
	server_iter = self.cfg.vncList.get_iter((vnc_server,))
	for client in range(self.cfg.vncList.iter_n_children(server_iter)):
	    self.vnc_client_disable(vnc_server, client)
	    # иконка в основном списке
	    user = self.cfg.vncList[(vnc_server,client)][1]
	    server = self.cfg.vncList[(vnc_server,client)][4]
	    row = find_tree(self.cfg, self.cfg.userList, user, server)
	    if ( row != False ):
		self.cfg.userList[row][53] = None

    def vnc_client_disable(self, vnc_server, client):
	self.cfg.vncList[(vnc_server,client)][59] = None
    	self.cfg.vncList[(vnc_server,client)][60] = None
	user = self.cfg.vncList[(vnc_server,client)][1]
	server = self.cfg.vncList[(vnc_server,client)][4]
	row = find_tree(self.cfg, self.cfg.userList, user, server)
	if ( row != False ):
	    self.cfg.userList[row][53] = None
	
####################################################################################################

