#! /usr/bin/env python
# -*- coding: utf8 -*-

import gtk, pwd, string, socket, gettext
_ = gettext.gettext

from util import *
from threads import thread_gfunc

####################################################################################################

def create_userList(cfg):

    # список псевдонимов, у групп и автономных клиентов свои псевдонимы
    alias_list = load_aliasList(cfg)

    cfg.userList.clear()
    create_tree_group(cfg)

    servers = []

    server_list = cfg.read_config("servers","server_list")
    for x in range(int(server_list)):
	z = string.split(cfg.read_config("servers","server"+str(x+1)), ",")
	servers.append(z)

    dn = cfg.dn

    for server in servers:
	d = {}
	for value, key in zip(server, cfg.z):
	    d[key] = value
	
	parent = cfg.userList.append(None)
	cfg.userList.set(parent, 50, cfg.pixbuf_status_server_16)

	for x in range(len(server)):
	    if ( server[int(x)] == None ):
		server[int(x)] = ""
    	    cfg.userList.set(parent, int(x), server[int(x)])

	if ( server[0] not in cfg.localhost and validate("ip", server[0] ) == False ):
    	    cfg.status(_("Wrong")+" IP "+_("address")+" ("+server[0]+")")
    	    continue
	if ( server[0] not in cfg.localhost and nmap_socket(cfg, server[0],"22", d['timeout'],None) == "0" ):
	    continue

	if ( server[0] in cfg.localhost ):
	    # user, host, display
	    clients = get_user_env(cfg, "clients", None, d['server_key'], d['server_port'], d['server_user'], server[0])
    	    # ip, mac
	    arp = get_user_env(cfg, "arp", None, d['server_key'], d['server_port'], d['server_user'], server[0])
	    # desktop
	    desktops = get_user_env(cfg, "desktops", None, d['server_key'], d['server_port'], d['server_user'], server[0])
	    # passwd
	    #user:x:uid:gid:gecos:home:shell
	    passwd = get_user_env(cfg, "passwd", None, d['server_key'], d['server_port'], d['server_user'], server[0])
	else:
	    (clients, arp, desktops, passwd) = get_user_env(cfg, "all", None, d['server_key'], d['server_port'], d['server_user'], server[0])

	if ( clients == [] ):
	    continue
	    
	for line in clients:
    	    line_parts = string.split(line)
    	    user = line_parts[0]
    	    
    	    if ( server[0] in cfg.localhost and user == cfg.local_user ):
    		continue
    	    
    	    alias = user
    	    display = line_parts[1]
    	    host = line_parts[4].strip('()')
    	    mac = "0"
    	    vncport = d['vncport']
    	    ip = "0"
    	    desktop = "unknown"
    	    start_time = line_parts[2]+" "+line_parts[3]
    	    uid = ""

    	    # client
    	    if ( display.split(":")[0] == "" ): 
    	        ip = host
    	        client = "nx"
    	    else:
    		client = "xdmcp"
    		
    	    if (user != "root" and host != "root"):
    	        # mac-address
    	        for line2 in arp:
    		    line2_parts = string.split(line2)
    		    if ( line2_parts[0] == host ):
    			ip = line2_parts[1]
    		    	mac = line2_parts[2]
    		    	break
    		# passwd
		#user:x:uid:gid:gecos:home:shell
    	        for line2 in passwd:
    		    line2_parts = line2.split(":")
    		    if ( line2_parts[0] == user  ):
    		        uid = line2_parts[2]
    		        if ( cfg.gecosAlias == "y" ):
    		    	    alias = line2_parts[4]
    		        break
    	        # desktops
    	        for line2 in desktops:
    		    line2_parts = string.split(line2)
    		    if ( line2_parts[0] == user or line2_parts[0] == uid ):
    		        desktop = line2_parts[1]
    		        break
    		
    		# alias
		for item in alias_list:
		    if ( user == item[0] ):
			alias = item[1]
			break
    		# add row in userList
    		# Поиск в группах user,host
    		if ( find_tree(cfg,cfg.userList,user,server[0],None,True) == False ):
            	    cfg.userList.append(parent, [\
            		alias,user,host,ip,server[0],\
            		client,start_time,mac,desktop,"server",\
            		server[10],server[11],server[12],server[13],server[14],\
            		server[15],server[16],server[17],server[18],server[19],\
            		server[20],server[21],server[22],server[23],vncport,\
            		server[25],server[26],server[27],display,uid,\
            		server[30],server[31],server[32],server[33],server[34],\
            		server[35],server[36],server[37],server[38],server[39],\
            		server[40],server[41],server[42],server[43],server[44],\
            		server[45],server[46],server[47],server[48],server[49],\
            		None,None,None,None,None,None,None,None,None,None])
    # client icons
    i = -1
    for parents in cfg.userList:
    	i += 1
	parent_iter = cfg.userList.get_iter(i)
    	for y in range(cfg.userList.iter_n_children(parent_iter)):
    	    row = (i,y)
    	    # type
    	    if ( cfg.userList[row][dn['client']] == "standalone" ):
    		cfg.userList[row][57] = cfg.pixbuf_status_st_16
	    elif ( cfg.userList[row][dn['client']] == "nx" ):
    		cfg.userList[row][57] = cfg.pixbuf_status_nx_16
	    else:
    		cfg.userList[row][57] = cfg.pixbuf_status_xdmcp_16
	    # desktop
    	    if ( cfg.userList[row][dn['desktop']] == "kde3" ):
    		cfg.userList[row][56] = cfg.pixbuf_status_kde3_16
	    elif ( cfg.userList[row][dn['desktop']] == "gnome2"  ):
    		cfg.userList[row][56] = cfg.pixbuf_status_gnome2_16
	    elif ( cfg.userList[row][dn['desktop']] == "windows"  ):
    		cfg.userList[row][56] = cfg.pixbuf_status_windows_16
	    else:
    		cfg.userList[row][56] = cfg.pixbuf_status_unknown_16

####################################################################################################

def check_vnc_on_st(cfg):
    
    thread = thread_gfunc(cfg, False, True, check_vnc_on_st_t, cfg)
    thread.start()

def check_vnc_on_st_t(cfg):
    dn = cfg.dn
    for x in range(len(cfg.userList)):
	parent_iter = cfg.userList.get_iter(x)
    	for y in range(cfg.userList.iter_n_children(parent_iter)):
    	    if ( cfg.userList[(x,y)][dn['client']] == "standalone" and cfg.userList[(x,y)][dn['vnc_create']] == "True" ):
    		port = nmap_os(cfg, "127.0.0.1", cfg.userList[(x,y)][dn['vncport']], cfg.userList[(x,y)][dn['timeout']],\
    		    False, cfg.userList[(x,y)][dn['host_key']], cfg.userList[(x,y)][dn['host_port']],\
    		    cfg.userList[(x,y)][dn['host_user']], cfg.userList[(x,y)][dn['ip']], None)
		if ( port == "0" ):
	    	    create_vnc_on_st(cfg, (x,y))
    
def create_vnc_on_st(cfg, row):
    dn = cfg.dn
    ssh = cfg.ssh_command(cfg.userList[row][dn['host_key']], cfg.userList[row][dn['host_port']],\
	cfg.userList[row][dn['host_user']], cfg.userList[row][dn['ip']], " -f ")
    
    command = cfg.userList[row][dn['vnc_server']]+" -shared -forever -localhost -quiet -rfbport "+cfg.userList[row][dn['vncport']]+\
	" -display "+cfg.userList[row][dn['display']]
    cmd = ssh+" "+command
    proc = popen_sub(cfg, cmd.split(), False, False)
    
####################################################################################################

def userList_column_value(cfg, column, value, user_list, parent=True):
    for z in user_list:
	row = find_tree(cfg, cfg.userList, z[1], z[4])
	if ( row == False ):
	    continue
	if ( parent ):
	    cfg.userList[(row[0],)][column] = value
	cfg.userList[row][column] = value

####################################################################################################

def load_aliasList(cfg):
    alias_list = []
    alias1 = cfg.read_config("alias","alias1")
    z = string.split(alias1, ",")
    for item in range(int(len(z)/2)):
        alias_list.append( [z[item*2], z[item*2+1]] )
    return alias_list

####################################################################################################

def save_aliasList(cfg, user, alias):
    alias_list = load_aliasList(cfg)
    cfg.remove_config("alias")
    cfg.write_config("alias")
    alias1 = ""
    check = False
    for item in alias_list:
	if ( user == item[0] ):
	    item[1] = alias
	    check = True
	alias1 = alias1+item[0]+","+item[1]+","
	
    if ( check == False ):
        alias1 = alias1+user+","+alias+","
    cfg.write_config("alias", "alias1", alias1[:-1])
    
####################################################################################################

def create_tree_group(cfg):
    cfg.groups = cfg.read_config("group","group_list")
    for x in range(int(cfg.groups)):
    	(name, hosts)= string.split(cfg.read_config("group","g"+str(x+1)), ",")
	parent = cfg.userList.append(None)
	cfg.userList.set(parent, 0, name)
	cfg.userList.set(parent, 50, cfg.pixbuf_status_group_16)
	for y in range(int(hosts)):
	    z = string.split(cfg.read_config("group","g"+str(x+1)+"_"+str(y+1)), ",")
	    iter = cfg.userList.append(parent)
    	    for item in range(len(z)):
		cfg.userList.set(iter, int(item), z[int(item)])
    # Проверка и создание VNC сервера на автономных клиентах
    check_vnc_on_st(cfg)

####################################################################################################

def remove_tree_item(cfg, treeview):
    # Нельзя удалить позиции в серверах
    model, rows = treeview.get_selection().get_selected_rows()
    parent_iters = []
    child_iters = []
    for row in rows:
        group = model[row[0]][4]
        if ( group == "server" and model[row][1] != "" ):
    	    continue
	if ( len(row) == 1 ):
    	    parent_iters.append(model.get_iter(row))
    	else:
    	    child_iters.append(model.get_iter(row))
    for iter in child_iters:
        if ( iter != None ):
	    model.remove(iter)
    for iter in parent_iters:
        if ( iter != None ):
    	    model.remove(iter)
    save_userList(cfg)

####################################################################################################

def get_selected_tree(treeView, mode=None):
    user_list = []
    model, rows = treeView.get_selection().get_selected_rows()
    if ( rows == [] ):
        return []

    if ( mode == "first" or mode == "edit" ):
    	# Раскрыть и выделить первую позицию
	row = rows[0]
	if( len(row) == 1 and mode != "edit" ):
	    parent_iter = model.get_iter(row)
	    if ( model.iter_n_children(parent_iter) == 0 ):
	        return []
	    else:
	        row = (row[0],0)
    	treeView.scroll_to_cell(row, None, use_align=True, row_align=0.5, col_align=0.0)
    	treeView.expand_to_path(row)
    	treeView.get_selection().unselect_all()
    	treeView.get_selection().select_path(row)
    	model, rows = treeView.get_selection().get_selected_rows()
	    
    # группы и сервера
    if ( mode != "edit" ):
        server_rows = []
    	for row in rows:
    	    if ( len(row) == 1 ):
    		server_rows.append(row)
		parent_iter = model.get_iter(row)
		if ( range(model.iter_n_children(parent_iter)) != [] ):
	    	    for y in range(model.iter_n_children(parent_iter)):
    			t = (int(row[0]), int(y))
    			rows.append(tuple(t))
    	if ( server_rows != [] ):
    	    for row in server_rows:
    	        rows.remove(row)

    for row in rows:
        z = []
        for part in range(50):
    	    z.append(model[row][part])
    	user_list.append(z)
    return user_list
    
####################################################################################################

def tree_drag_data_get(treeview, context, selection, target_id, etime, cfg):
    treeselection = treeview.get_selection()
    model, rows = treeselection.get_selected_rows()
    txt = ""
    data = ""
    for z in get_selected_tree(treeview):
        for x in range(50):
    	    data = data+z[x]+","
	txt = txt+data[:-1]+"\n"
	data = ""
    selection.set(selection.target, 8, txt)

####################################################################################################

def tree_drag_data_received(treeView, context, x, y, selection, info, etime, cfg, tree="userList"):
    # Перетаскивание в дереве
    model, rows = treeView.get_selection().get_selected_rows()
    if ( rows == [] ): return

    drop_info = treeView.get_dest_row_at_pos(x, y)
    if not drop_info: return
        
    dest_path, dest_position = drop_info
    parent = model[dest_path[0]][0]
    dest_iter = model.get_iter(dest_path)
    # Нельзя перетаскивать в сервера
    if ( drop_info and model[dest_path[0]][4] != "server" ):
	# перетащить несколько?
    	for row in rows:
    	    # Нельзя переместить сервер или группу
    	    if ( len(row) == 1 ):
    	        continue
    	    row_data = model[rows[0]]
    	    row_iter = model.get_iter(rows[0])
    	    new_iter = None
    	    # нельзя создать новый парент
    	    if ( len(dest_path) == 1 ):
    	        new_iter = model.append(dest_iter, row_data)
    	    elif (dest_position == gtk.TREE_VIEW_DROP_BEFORE or dest_position == gtk.TREE_VIEW_DROP_INTO_OR_BEFORE):
    	        new_iter = model.insert_before(None, dest_iter, row_data)
    	    else:
    	        new_iter = model.insert_after(None, dest_iter, row_data)
    	    if ( new_iter ):
    		model.set(new_iter, 9, parent)
    	    model.remove(row_iter)
	# Сохранить после изменения
	treeView.expand_to_path(dest_path)
	if ( tree == "userList" ):
	    save_userList(cfg)
	elif ( tree == "vncList" ):
	    save_vncList(cfg)

####################################################################################################

def create_columns(cfg, treeView, list_col, visible=None):
    i = -1
    for col in list_col:
	i += 1
	if ( col == "pixbuf" ):
    	    renderer = gtk.CellRendererPixbuf()
    	    column = gtk.TreeViewColumn("", renderer, pixbuf=i)
    	    column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
    	    column.set_fixed_width(28)    
    	else:
    	    renderer = gtk.CellRendererText()
    	    column = gtk.TreeViewColumn(col, renderer, text=i)
    	    column.set_expand(True)
    	column.set_visible(True)
	treeView.append_column(column)

####################################################################################################

def save_vncList(cfg):
    cfg.remove_config("vnc_servers")
    cfg.write_config("vnc_servers")
    cfg.write_config("vnc_servers", "vnc_servers_list", "1")
    for x in range(len(cfg.vncList)):
	server = ""
    	for part in range(60):
    	    if ( type(cfg.vncList[(x,)][part]) == str ):
        	server = server+str(cfg.vncList[(x,)][part])+","
	    else:
    	        server = server+","
    	cfg.write_config("vnc_servers", "vnc_server_list", str(x+1))
    	cfg.write_config("vnc_servers", "vnc_server"+str(x+1)+"_users", "0")
    	cfg.write_config("vnc_servers", "vnc_server"+str(x+1), server[:-1])
	parent_iter = cfg.vncList.get_iter(x)
    	for y in range(cfg.vncList.iter_n_children(parent_iter)):
    	    cfg.write_config("vnc_servers", "vnc_server"+str(x+1)+"_users", str(y+1))
    	    user = ""
    	    for part in range(60):
        	if ( type (cfg.vncList[(x,y)][part]) == str  ):
        	    user = user+str(cfg.vncList[(x,y)][part])+","
		else:
        	    user = user+","
    	    cfg.write_config("vnc_servers", "vnc_server"+str(x+1)+"_"+str(y+1), user[:-1])

###################################################################################################

def save_userList(cfg):
    cfg.remove_config("servers")
    cfg.write_config("servers")
    cfg.write_config("servers", "server_list", "0")
    cfg.remove_config("group")
    cfg.write_config("group")
    cfg.write_config("group", "group_list", "0")
    servers = 0
    groups = 0
    for x in range(len(cfg.userList)):
	server = cfg.userList[x][0]
	group = cfg.userList[x][4]
	parent_iter = cfg.userList.get_iter((x,))
    	if ( group == "server" ):
	    servers += 1
    	    cfg.write_config("servers", "server_list", str(servers))
    	    item = ""
    	    for part in range(50):
    	        if ( cfg.userList[(x,)][part] == None ):
    	    	    cfg.userList[(x,)][part] = ""
        	item = item+str(cfg.userList[(x,)][part])+","
    	    cfg.write_config("servers", "server"+str(servers), item[:-1])
    	else:
	    groups += 1
    	    cfg.write_config("group", "group_list", str(groups))
    	    cfg.write_config("group", "g"+str(groups), cfg.userList[x][0]+","\
    	        +str(cfg.userList.iter_n_children(parent_iter)))
    	    for y in range(cfg.userList.iter_n_children(parent_iter)):
        	item = ""
        	for part in range(50):
        	    if ( cfg.userList[(x,y)][part] == None ):
        	        cfg.userList[(x,y)][part] = ""
        	    item = item+str(cfg.userList[(x,y)][part])+","
    	        cfg.write_config("group", "g"+str(groups)+"_"+str(y+1), item[:-1])

####################################################################################################

def find_tree(cfg, tree, user, server, parent=None, group=None):
    # Поиск user,server в дереве userList
    # Если parent, возвращает iter на него или False
    # Если group - поиск user,host только в группах
    i = -1
    if ( parent ):
        for parents in tree:
    	    i +=1
    	    if ( parent == tree[i][0] ):
    		return tree.get_iter(i)
    if ( parent == None ):
        for parents in tree:
    	    i += 1
    	    if ( group == True and parents[4] == "server" ):
    		continue
	    parent_iter = tree.get_iter(i)
    	    for y in range(tree.iter_n_children(parent_iter)):
    	        row = (i,y)
    	        if ( user == tree[row][1] and server == tree[row][4] ):
    		    return row
		    break
    return False

####################################################################################################    

def save_timersList(cfg):
    cfg.remove_config("timers")
    cfg.write_config("timers")
    for timer in range(len(cfg.timersList)):
        row = (timer,)
        number = cfg.timersList[row][0]
    	action = cfg.timersList[row][1]
    	start = cfg.timersList[row][2]
    	command = cfg.timersList[row][3]
    	user_list = cfg.timersList[row][5]
    	if ( user_list == None ):
    	    user_list = []
    	    users = "0"
    	else:
    	    users = str(len(user_list))
	cfg.write_config("timers", "timer_list", str(timer+1))
	cfg.write_config("timers", "t"+str(timer+1), action+","+start+","+command)
	cfg.write_config("timers", "t"+str(timer+1)+"_users", users)
	user = 0
	for z in user_list:
	    user += 1
	    user_s = ""
	    for item in range(len(z)):
		user_s = user_s+z[item]+","
	    cfg.write_config("timers", "t"+str(timer+1)+"_user"+str(user), user_s[:-1])

####################################################################################################    

def create_timersList(cfg):
    cfg.timersList.clear()
    timers = cfg.read_config("timers","timer_list")
    for x in range(int(timers)):
    	(action,start,command)= cfg.read_config("timers","t"+str(x+1)).split(",")
    	users = cfg.read_config("timers","t"+str(x+1)+"_users")
    	user_list = []
	for y in range(int(users)):
    	    z = cfg.read_config("timers","t"+str(x+1)+"_user"+str(y+1)).split(",")
    	    user_list.append(z)
    	timer_iter = cfg.timersList.append(None, [x+1,action,start,command,None,user_list,0])
    	for z in user_list:
    	    cfg.timersList.append(timer_iter, ["",z[0],"","",None,"",0])

####################################################################################################    

def create_vncList(cfg):
    cfg.vncList.clear()
    # Локальный
    servers = cfg.read_config("vnc_servers","vnc_server_list")
    for x in range(int(servers)):
	server = cfg.read_config("vnc_servers","vnc_server"+str(x+1)).split(",")
	users = cfg.read_config("vnc_servers","vnc_server"+str(x+1)+"_users")
	server_iter = cfg.vncList.append(None)
	for z in range(len(server)):
    	    cfg.vncList.set(server_iter, int(z), server[int(z)])
	for y in range(int(users)):
    	    user = cfg.read_config("vnc_servers","vnc_server"+str(x+1)+"_"+str(y+1)).split(",")
	    user_iter = cfg.vncList.append(server_iter)
	    for z in range(len(user)):
    		cfg.vncList.set(user_iter, int(z), user[int(z)])

####################################################################################################    

####################################################################################################    
