#! /usr/bin/env python
# -*- coding: utf8 -*-

import gtk, string, re, gettext, shlex
import os, time, subprocess, socket
_ = gettext.gettext


####################################################################################################

def ssh_tunnel(cfg, ssh_key, ssh_port, ssh_user, ip, server, port, mode="-fL"):

    if ( port == "0" ):
	return "0"
	
    if ( mode == "-fL" ):
	local_port = nmap_socket(cfg,"","","",True,ssh_user)
    else:
	local_port = nmap_os(cfg,"","","",True,ssh_key,ssh_port,ssh_user,ip)
	
    command = cfg.ssh_command(ssh_key, ssh_port, ssh_user, ip, mode+" "+local_port+":"+server+":"+port)+" sleep 30"

    proc = popen_sub(cfg, command.split())
    if ( proc == False ):
	return "0"
    else:
	return local_port

####################################################################################################

def popen_sub(cfg, cmd, shell=False, error=True):

    try:
	proc = subprocess.Popen(cmd, shell=shell, stdin=None, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
    except:
	if ( error ):
	    if ( len(cmd) > 0 ):
    		cfg.status("System error"+" "+cmd[0]+"")
    	    else:
    		cfg.status("System error")
	return False
	
    user_host = ""
    for x in range(len(cmd)):
        if ( "@" in cmd[x] ):
    	    user_host = cmd[x].split(":")[0]
    
    # Проверка ошибок
    time_start = time.time()
    while True:
	if ( "DISPLAY" in str(cmd) or "'-t'" in str(cmd) ):
	    if ( time_start+0.5 < time.time() ):
		break
	else:
	    if ( time_start+3 < time.time() ):
		return False
	if ( proc.poll() != None ):
	    break

    if ( proc.poll() != None and proc.poll() != 0 ):
	err = proc.stderr.readline().strip()
	if ( err != "" and error ):
    	    cfg.status(user_host+" "+cmd[0]+": "+err+"")
    	return False

    return proc

####################################################################################################

def popen_os(cmd):

    return os.popen(cmd)

####################################################################################################

def cursor_wait(cfg, wait, widget=None):
    if ( not widget ):
	widget = cfg.window
    if ( wait ):
	if ( not cfg.cursor_wait_status and widget.window ):
		#pixbuf = gtk.gdk.pixbuf_new_from_file("/home/admin/.vnc/icons/cursor_watch.gif")
		#widget.window.set_cursor(gtk.gdk.Cursor(widget.get_display(), pixbuf, 30, 30))
		gtk.gdk.threads_enter()
		widget.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))
		gtk.gdk.threads_leave()
		cfg.cursor_wait_status = True
    else:
	if ( cfg.cursor_wait_status and widget.window ):
		gtk.gdk.threads_enter()
		widget.window.set_cursor(None)
		gtk.gdk.threads_leave()
		cfg.cursor_wait_status = False

####################################################################################################

def nmap_socket(cfg, ip, port, timeout, closed=None, user=""):
    if ( closed ):
        # Возвращает локальный свободный порт
        # Для других серверов nmap_os
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.bind(('', 0))
        s.listen(1)
        port = s.getsockname()[1]
        s.close()
	return str(port)
    else:
        s = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
        s.setblocking(0)
        timeout = float(timeout)/1000
        s.settimeout(timeout)
        result = s.connect_ex((ip, int(port)))
        if(result == 0) :
    	    check = str(port)
    	else:
    	    check = str(0)
    	    cfg.status(user+"@"+ip+" "+_("not available")+" "+_("or")+" "+_("port")+" "+port+" "+_("blocking"))
    	s.close()
    	return check

####################################################################################################

def nmap_os(cfg, ip, port, timeout, closed=None, ssh_key=None, ssh_port=None, ssh_user=None, server=None, user=None):

    ssh = ""
    if ( server and ssh_user and ssh_port ):
    	ssh = cfg.ssh_command(ssh_key, ssh_port, ssh_user, server)

    if ( closed ):
	cmd = ssh+cfg.nmap_command+" -d2 -p 50000-50200 127.0.0.1"
	proc = popen_sub(cfg, cmd.split(), False, False)
	if ( proc == False ):
	    return "0"
	else:
	    port = "0"
	    for x in proc.stdout.readlines():
		if ( "closed unknown" in x ):
		    port = x.split("/")[0]
		    break
    	    return port
    else:
	cmd = ssh+cfg.nmap_command+"--initial-rtt-timeout "+timeout+" "+ip+" -p "+port
	proc = popen_sub(cfg, cmd.split(), False, False)
	if ( proc == False ):
	    return False
	else:
	    check = "0"
	    for x in proc.stdout.readlines():
		if ( "open" in x ):
		    check = x.split("/")[0]
		    break
	    if ( check != "0" ): 
		return check
	    else:
		if ( user ):
    		    cfg.status(user+"@"+ip+" "+_("not available")+" "+_("or")+" "+_("port")+" "+port+" "+_("blocking"))
		return "0"

####################################################################################################

def get_workspace():
    w = gtk.gdk.get_default_root_window()
    p = gtk.gdk.atom_intern('_NET_WORKAREA') 
    return (w.property_get(p)[2][2:4][0]-10, w.property_get(p)[2][2:4][1]-30)

####################################################################################################

def get_clients(out, data):
    clients = []
    for x in out:
        if ( ("root" in x) or ("pts" in x) or ("localhost" in x) ):
    	    continue
	else:
	    clients.append(x)
    clients = uniqueItemsList(clients)
    clients.sort()
    # для одного поиск по пользователю
    if ( data ):
        for x in clients:
    	    line = string.split(x)
    	    if ( data == line[0] ):
	        return x.split()
	return False
    return clients
##################################################
def get_arp(out, data):
    arp = []
    for x in out:
	if ( "incomplete" in x or "?" in x ):
	    pass
	else:
    	    line = string.split(x)
	    host = line[0]
	    ip = line[1].strip("()")
	    mac = line[3]
	    arp.append(host+" "+ip+" "+mac)
    # для одного поиск по mac
    # return ip
    if ( data ):
	for x in arp:
    	    if ( string.split(x)[2] == data ):
		return string.split(x)[1]
	return False
    return arp
##################################################
def get_desktops(out, data):
    desktops = []
    for x in out:
        line = string.split(x)
        if ( "grep" in x ):
	    pass
	elif (  "kded4" in line[1] ):
	    desktops.append(line[0]+" kde4")
	elif (  "kded" in line[1] ):
	    desktops.append(line[0]+" kde3")
	elif (  "gnome-session" in line[1] ):
	    desktops.append(line[0]+" gnome2")
    # для одного поиск по пользователю
    # return desktop
    if ( data ):
        for x in desktops:
            line_parts = string.split(x)
    	    if ( line_parts[0] == data ):
    		return line_parts[1]
    	return False
    return desktops
##################################################
def get_user_env(cfg, mode, data, ssh_key, ssh_port, ssh_user, server):
    
    if ( server in cfg.localhost and mode != "env"):
        ssh = ""
    else:
	ssh = cfg.ssh_command(ssh_key, ssh_port, ssh_user, server)
	
    if ( mode == "clients" ):
	# user, host, display
	cmd = ssh+cfg.who_command
	proc = popen_sub(cfg, cmd.split())
	if ( proc == False ):
	    return []
	out = proc.stdout.readlines()
	return get_clients(out, data)
    	    
    elif ( mode == "arp" ):
    	# ip, mac
	cmd = ssh+cfg.arp_command
	proc = popen_sub(cfg, cmd.split())
	if ( proc == False ):
	    return []
	out = proc.stdout.readlines()
	return get_arp(out, data)
	    
    elif ( mode == "desktops" ):
	# desktops
	cmd = ssh+cfg.ps_command+" -Ao user,comm"
	proc = popen_sub(cfg, cmd.split())
	if ( proc == False ):
	    return []
	out = proc.stdout.readlines()
	return get_desktops(out, data)

    elif ( mode == "passwd" ):
	# uid
	cmd = ssh+" getent passwd"
	proc = popen_sub(cfg, cmd.split())
	if ( proc == False ):
	    return []
	out = proc.stdout.readlines()
	return out

    elif ( mode == "all" ):
	cmd = ssh+cfg.who_command+" ;echo ---\n ; "+cfg.arp_command+" ;echo ---\n ; "+cfg.ps_command+" -Ao user,comm "+\
	    " ;echo ---\n ; "+"getent passwd"
	proc = popen_sub(cfg, cmd.split())
	if ( proc == False ):
	    return [], [], [], []
	out = proc.stdout.read()
	if ( out == "" ):
    	    return [], [], [], []
    	(out_clients, out_arp, out_desktops, out_passwd) = out.split("---\n")
    	
	passwd = out_passwd.splitlines()
	clients = get_clients(out_clients.splitlines(), None)
	arp = get_arp(out_arp.splitlines(), None)
	desktops = get_desktops(out_desktops.splitlines(), None)
	passwd = out_passwd.splitlines()
	return clients, arp, desktops, passwd

    elif ( data and mode == "env" ):
	cmd = ssh+" env"
	proc = popen_sub(cfg, cmd.split())
	if ( proc == False ):
	    return []
	out = proc.stdout.readlines()
	return out

    else:
        return []
    
####################################################################################################

def get_x11vnc_port(cfg, user, ssh_key, ssh_port, ssh_user, server):

    ssh = cfg.ssh_command(ssh_key, ssh_port, ssh_user, server)
    cmd = ssh+cfg.netstat_command+" -apt"
    proc = popen_sub(cfg, cmd.split())
    if ( proc == False ):
        return "0"
    out = proc.stdout.readlines()
    
    vncport = "0"
    for x in out:
	if ( "ssh" in x ):
	    continue
	elif ( "x11vnc" in x ):
	    vncport = string.split(x)[3].split(":")[1]
    return vncport

####################################################################################################

def uniqueItemsList(list):
    # Возвращает уникальную версию списка
    u = []
    for x in list:
        if x not in u:
            u.append(x)
    return u

####################################################################################################

def validate(mode, data):

    if ( mode == "username" ):
	pattern = r"^[a-zA-Z0-9_]+$"
	if re.match(pattern, data):
	    return True
	else:
	    return False
    if ( mode == "host" ):
	pattern = r"^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$"
	if re.match(pattern, data):
	    return True
	else:
	    return False
    if ( mode == "port" ):
	pattern = r"^0*(?:6553[0-5]|655[0-2][0-9]|65[0-4][0-9]{2}|6[0-4][0-9]{3}|[1-5][0-9]{4}|[1-9][0-9]{1,3}|[0-9])$"
	if re.match(pattern, data):
	    return True
	else:
	    return False
    if ( mode == "ip" ):
	pattern = r"\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b"
	if re.match(pattern, data):
	    return True
	else:
	    return False
    if ( mode == "mac" ):
	pattern = r"([\dA-F]{2}(?:[-:][\dA-F]{2}){5})"
	if re.match(pattern, data):
	    return True
	else:
	    return False

####################################################################################################

def check_user_list(cfg, user_list, mode):
    if ( user_list == [] ):
        return []
    user_list_mod = []

    for z in user_list:
	d = {}
	for key, value in zip(cfg.z, z):
	    d[key] = value

    	# NX
    	NX = False
    	if ( d['client'] == "nx" and cfg.vncNxHost != "y" ):
    	    NX = True

	if ( d['server'] not in cfg.localhost ):
	    name = _("Server")
	    if ( d['client'] == "standalone" ):
		name = d['alias']
	    if ( nmap_socket(cfg, d['server'],d['server_port'],d['timeout'], None, name) == "0" ):
	        continue

    	if ( validate("ip", d['ip'] ) == False ): 
    	    cfg.status(_("Wrong")+" IP "+_("address")+" "+d['alias']+"("+d['ip']+")")
    	    continue
    	    
    	if ( NX and mode != "ssh" ):
    	    pass
    	elif ( mode == "command" ):
    	    pass
    	elif ( mode == "empty" ):
    	    pass
    	elif ( mode == "vnc" and d['over_server'] == "True" ):
    	    if ( d['vnc_normal'] == "True" ):
		if ( nmap_os(cfg,d['ip'],d['vncport'],d['timeout'],None,d['server_key'],d['server_port'],d['server_user'],d['server'],d['alias']) == "0" ):
		    d['vnc_normal'] = "False"
    	    if ( d['vnc_ssh'] == "True" and d['vnc_normal'] == "False" ):
	        if ( nmap_os(cfg,d['ip'],d['host_port'],d['timeout'],None,d['server_key'],d['server_port'],d['server_user'],d['server'],d['alias']) == "0" ):
	    	    d['vnc_ssh'] = "False"
    	elif ( mode == "vnc" ):
    	    if ( d['vnc_normal'] == "True" ):
    		if ( nmap_socket(cfg, d['ip'], d['vncport'], d['timeout'], None, d['alias']) == "0" ):
		    d['vnc_normal'] = "False"
    	    if ( d['vnc_ssh'] == "True" and d['vnc_normal'] == "False" ):
    	        if ( nmap_socket(cfg, d['ip'], d['host_port'], d['timeout'], None, d['alias']) == "0" ):
    	    	    d['vnc_ssh'] = "False"
    	elif ( mode == "ssh" ):
    	    if ( d['over_server'] == "True" ):
	        if ( nmap_os(cfg,d['ip'],d['host_port'],d['timeout'],None,d['server_key'],d['server_port'],d['server_user'],d['server'],d['alias']) == "0" ):
	    	    continue
    	    elif ( nmap_socket(cfg,d['ip'],d['host_port'],d['timeout'],None,d['alias']) == "0" ):
	        continue
	
    	# получение IP для "dynamic DHCP"
    	# кроме NX клиентов, нет MAC
    	if ( d['dhcp'] != "static" and d['client'] != "nx" ):
    	    # host,ip
	    arp = get_user_env(cfg, "arp", d['mac'], d['server_key'], d['server_port'], d['server_user'], d['server'])
	    if ( arp == False ):
	        cfg.status("IP "+_("address")+" "+_("not found")+" - "+d['alias']+","+d['user']+","+d['host']+"  "+_("Server")+":"+d['server'])
	        continue
	    else:
		d['ip'] = arp

	# Проверка наличия пользователя(who)
	# Проверка номера дисплея для NX, +host,ip. Для VNC только если создается x11vnc
	if ( (mode == "command" ) or (d['client'] == "nx" and d['dhcp'] != "static") or (d['client'] == "nx" and mode != "vnc")\
	    or (d['client'] == "nx" and mode == "vnc" and cfg.vncNxCreate =="y") ):
    	    client = get_user_env(cfg, "clients", d['user'], d['server_key'], d['server_port'], d['server_user'], d['server'])
	    if ( client == False ):
	        cfg.status(d['user']+"@"+d['server']+"("+d['alias']+")"+" - "+_("User")+" "+_("not found"))
	        continue
	    else:
	        d['host'] = client[4].strip('()')
	        d['display'] = client[1]
	    
	# Проверка рабочего стола
	#desktop = get_user_env(cfg, "desktops", d['user'], d['server_key'], d['server_port'], d['server_user'], d['server'])
	#if ( desktop == False ):
	#    cfg.status(_("not found")+" - "+d['alias']+","+d['user']+","+d['host']+"  "+_("Server")+":"+d['server'])
	#    continue
	#else:
    	#    d['desktop'] = desktop

    	# append return list
    	del z[:]
    	for i in range(len(cfg.z)):
    	    z.append(d[cfg.z[i]])
    	user_list_mod.append(z)
    return user_list_mod

####################################################################################################

