#! /usr/bin/env python
# -*- coding: utf8 -*-

import gtk, os, signal, string, gettext, time
import subprocess, gobject
_ = gettext.gettext

from util import *
from tree import find_tree
from tree import save_vncList
from command import run_command

####################################################################################################

def create_vnc_viewer(cfg, user_list, mode):
    
    z = check_user_list(cfg, user_list, "vnc")
    if ( z == [] ):
	return
    d = {}
    for key, value in zip(cfg.z, z[0]):
        d[key] = value

    # можно без пароля
    passwd = ""
    if ( d['vnc_pass_file'] == "" ):
	pass
    elif ( os.path.exists(d['vnc_pass_file']) ):
	passwd = "-passwd "+d['vnc_pass_file']+""
    else:
	cfg.status(_("Password")+" VNC "+_("not found")+" - "+d['vnc_pass_file'])
	return False

    for line in user_list:
	(ip, vncport, vncviewer) = vnc_razrulit(cfg, line)
    	if ( vncport == "0" ):
    	    continue
	cmd = vncviewer+" "+passwd+" "+mode+" "+ip+":"+vncport
	proc = popen_sub(cfg, cmd.split())

####################################################################################################

def create_vnc_server(cfg, vnc_server):
    # Для NX, x11vnc можно создать на сервере
    # Для XDMCP, создавать на клиенте    

    z = vnc_server
    server_iter = find_tree(cfg, cfg.vncList, "", "", z[0])
    if ( server_iter == False ):
        return

    d = {}
    for key, value in zip(cfg.z, z):
        d[key] = value

    if ( z[0] == "Local" ):
    	x11vnc_port = nmap_socket(cfg, "","","", True)
	cfg.vncList.set(server_iter, 51, cfg.local_ip)
    	if ( cfg.vncServerSsh == "n" ):
	    cfg.vncList.set(server_iter, 54, "False")
    	    local = ""
    	else:
	    cfg.vncList.set(server_iter, 54, "True")
    	    local = "-localhost"
	cmd = cfg.vncServer+" -shared -forever -viewonly "+local+" -quiet -rfbport "+x11vnc_port+" -display "+cfg.local_display
	proc = popen_sub(cfg, cmd.split())
    else:	
	ssh = cfg.ssh_command(z[55], z[52], z[50], z[51], " -t ")	
	# Поиск closed(свободных) портов
	# Если NX создать VNC сервер на сервере
	if ( d['client'] == "nx" and (d['server'] in cfg.localhost) ):
    	    x11vnc_port = nmap_socket(cfg, "","","", True)
	else:
    	    # поиск порта на клиенте
    	    x11vnc_port = nmap_os(cfg, "", "", d['timeout'], True, z[55], z[52], z[50], z[51], None)

    	local = "-localhost"
    	if ( z[54] == "False" ):
    	    local = ""
	command = d['vnc_server']+" -shared -forever -viewonly "+local+" -quiet -rfbport "+x11vnc_port+" -display "+d['display']
	cmd = ssh+" "+command
	proc = popen_sub(cfg, cmd.split())

    if ( proc == False ):
        return False
    cfg.status(_("VNC server start")+" "+d['alias']+", "+_("port")+" "+x11vnc_port)
	
    time.sleep(1)
    cfg.vncList.set(server_iter, 53, x11vnc_port)
    cfg.vncList.set(server_iter, 58, str(proc.pid))
    cfg.vncList.set(server_iter, 63, proc)

####################################################################################################

def stop_vnc_server(cfg, vnc_server):
    
    z = vnc_server
    d = {}
    for key, value in zip(cfg.z, z):
        d[key] = value

    os.kill(int(z[58]), 15)
    cfg.status(_("VNC server stop")+" "+d['alias'])

####################################################################################################

def start_vnc_client(cfg, vnc_client, vnc_server):
    
    z = check_user_list(cfg, [vnc_client], "command")
    if ( z == [] ):
        return False
    d = {}
    for key, value in zip(cfg.z, z[0]):
        d[key] = value

    row = find_tree(cfg, cfg.vncList, d['user'], d['server'])
    if ( row == False ):
	return False

    z_server = vnc_server
    d_server = {}
    for key, value in zip(cfg.z, z_server):
        d_server[key] = value
    
    if ( z_server[51] == d['server'] or (d['server'] in cfg.localhost and z_server[51] in cfg.localhost) ):
	# если клиент и VNC сервер на одном сервере
	command = d['vnc_client']+" 127.0.0.1:"+z_server[53]
    	ssh = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'], " -t ")
	cmd = ssh+"export DISPLAY="+d['display']+".0;"+command
    elif ( z_server[54] == "False" ):
	# VNC без SSH
	command = d['vnc_client']+" "+z_server[51]+":"+z_server[53]
    	ssh = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'], " -t ")
	cmd = ssh+"export DISPLAY="+d['display']+".0;"+command
    else:
        # Два туннеля
        # 1 до сервера VNC
        # 2 до клиента
        # поиск локального порта
	
	# Если сервер на localhost или локальный сервер
	if ( z_server[51] in cfg.localhost or z_server[0] == "Local" ):
	    local_port = z_server[53]
	else:
    	    local_port = ssh_tunnel(cfg, z_server[55], z_server[52], z_server[50], z_server[51], "127.0.0.1", z_server[53], "-fL")
	    if ( local_port == "0" ):
		return False
	
	# Если клиент на localhost
	if ( d['server'] in cfg.localhost ):
	    remote_port = local_port
	else:
    	    # поиск порта на клиенте для туннеля
	    remote_port = ssh_tunnel(cfg, d['server_key'], d['server_port'], d['server_user'], d['server'], "127.0.0.1", local_port, mode="-fR")
	    if ( remote_port == "0" ):
	    	return False

	command = d['vnc_client']+" 127.0.0.1:"+remote_port
    	ssh = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'], " -t ")
    	cmd = ssh+"export DISPLAY="+d['display']+".0;"+command
    
    proc = popen_sub(cfg, cmd.split())
    if ( proc == False ):
    	return False
    
    time.sleep(1)
    cfg.vncList[row][59] = str(proc.pid)
    cfg.vncList[row][64] = proc

####################################################################################################

def stop_vnc_client(cfg, vnc_client, vnc_server=False):
    
    z = check_user_list(cfg, [vnc_client], "command")
    if ( z == [] ):
        return
    d = {}
    for key, value in zip(cfg.z, z[0]):
        d[key] = value
    
    # Если клиент standalone подменить данные
    if ( d['server'] == "standalone" ):
        d['server'] = d['ip']

    ssh = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'])
    command = "pkill -15 -u "+d['user']+" -f "+d['vnc_client'].split()[0]
    cmd = ssh+" "+command+" &"
    
    proc = popen_sub(cfg, cmd.split())
    if ( proc == False ):
    	return False

####################################################################################################

def vnc_razrulit(cfg, user_list_line, vnc_box=None ):
    # возвращает изменные данные под каждый тип клиента,
    # в порядке приоритета покдлючений
    # 1:vnc, 2:ssh.
    # Для удаленных приоритет 1:ssh over server 2:vnc 3:ssh.
	
    z = user_list_line
    d = {}
    for key, value in zip(cfg.z, z):
        d[key] = value

    if ( d['vnc_normal'] == "False" and d['vnc_ssh'] == "False" and d['client'] != "nx" ):
        return "0", "0", "0"
        
    # NX
    NX = False
    if ( d['client'] == "nx" ):
    	# vncNxHost иммитирует обычного тонкого клиента
    	if ( cfg.vncNxHost == "n" or (cfg.vncNxHost == "y" and d['vnc_normal'] == "False" and d['vnc_ssh'] == "False" ) ):
    	    d['vncport'] = "0"
    	    if ( cfg.vncNxScan == "y" ):
		# Поиск какой порт слушает x11vnc
    		d['vncport'] = get_x11vnc_port(cfg, d['user'], d['server_key'], d['server_port'], d['user'], d['server'])
    		if ( d['vncport'] != "0" ):
    	    	    NX = True
	    # Создание VNC сервера. Для миниатюр не используется
    	    if ( d['vncport'] == "0" and cfg.vncNxCreate =="y" and vnc_box != True ): 
    		# Поиск closed(свободных) портов
    		if ( d['server'] in cfg.localhost ):
    	    	    d['vncport'] = nmap_socket(cfg, "","","", True)
    		else:
    	    	    d['vncport'] = nmap_os(cfg, d['server'], "closed", d['timeout'], "5900", d['server'])
		command = d['vnc_server']+" -noshared -localhost -quiet -rfbport "+d['vncport']+" -display "+d['display']
		ssh = cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'], " -f ")
		cmd = ssh + command
		proc = popen_sub(cfg, cmd.split())
		if ( proc == False ):
		    return "0", "0", "0"
		time.sleep(2)
		NX = True
	    if ( d['vncport'] == "0" ):
    		return "0", "0", "0"
    if ( NX ):
    	d['ip'] = "127.0.0.1"
    else:
	if ( d['over_server'] == "True" ):
	    if ( d['vnc_ssh'] == "True" and d['vnc_normal'] == "False" ):
    		# VNC over SSH через удаленный сервер, через два туннеля
    		# 1 туннель для SSH
		port1 = ssh_tunnel(cfg, d['server_key'], d['server_port'], d['server_user'], d['server'], d['ip'], d['host_port'])
		if ( port1 == "0" ): return "0","0","0"
    		# 2 туннель для VNC
		d['vncport'] = ssh_tunnel(cfg, d['host_key'], port1, d['host_user'], "127.0.0.1", "127.0.0.1", d['vncport'])
		if ( d['vncport'] == "0" ): return "0","0","0"
    		d['ip'] = "127.0.0.1"
    	    else:
		d['vncport'] = ssh_tunnel(cfg, d['host_key'], d['host_port'], d['server_user'], d['server'], d['ip'], d['vncport'])
		if ( d['vncport'] == "0" ): return "0","0","0"
    		d['ip'] = "127.0.0.1"
	else:
    	    if ( d['vnc_ssh'] == "True" and d['vnc_normal'] == "False" ):
    		d['vncport'] = ssh_tunnel(cfg, d['host_key'], d['host_port'], d['host_user'], d['ip'], "127.0.0.1", d['vncport'])
		if ( d['vncport'] == "0" ): return "0","0","0"
    		d['ip'] = "127.0.0.1"
    
    return d['ip'], d['vncport'], d['vnc_command']

####################################################################################################

