#! /usr/bin/env python
# -*- coding: utf8 -*-

import gtk, os, string, gettext, time, gobject, pango
_ = gettext.gettext

from util import *
from vnc import *
from tree import create_columns
from tree import find_tree
from tree import save_userList
from tree import save_vncList
from tree import save_timersList
from tree import save_aliasList
from tree import create_timersList
from widget import *
from threads import thread_gfunc

####################################################################################################

def create_window2(cfg, window, table):
    umount_point(cfg)
    if ( table.get_children() == [] ): 
        cfg.mainWindowLastX = cfg.window_x
        if ( cfg.screen_x < cfg.window_x+cfg.panedWindowX ):
    	    window.move(0, 0)
    	    window.resize(cfg.screen_x, cfg.window_y)
    	else:
	    window.resize(cfg.window_x+cfg.panedWindowX, cfg.window_y)
	gobject.timeout_add(100, window_size_request, cfg, window)
    else:
        # очистка таблицы
        for x in table.get_children():
    	    table.remove(x)

def close_window2(data, cfg, window, table):
    if ( cfg.cursor_wait_status ):
	return
    umount_point(cfg)
    # очистка таблицы
    for x in table.get_children():
        table.remove(x)
    window.set_size_request(cfg.min_mainWindowX, cfg.min_mainWindowY)
    if ( cfg.mainWindowLastX < cfg.window_x - cfg.panedWindowX ):
	window.resize(cfg.window_x-cfg.panedWindowX, cfg.window_y)
    else:
	# -1 для открытого VNC после создания window2, чтобы закрыть ползунок
	window.resize(cfg.mainWindowLastX-1, cfg.window_y)

def window_size_request(cfg, window):
    window.set_size_request(cfg.min_mainWindowX+cfg.panedWindowX, cfg.min_mainWindowY)

####################################################################################################

def umount_point(cfg):
    if ( cfg.mount_point != None ):
	try:
	    ismount = os.path.ismount(cfg.mount_point)
	except:
	    return
	if ( ismount ):    
	    cmd = "fusermount -uz "+cfg.mount_point
	    proc = popen_sub(cfg, shlex.split(cmd))
	    cfg.mount_point = None

####################################################################################################

class folderUi:
    def __init__(self, cfg, window, table, user_list):
	
	user_list = check_user_list(cfg, user_list, "command")
	if ( user_list == [] ):
	    return
	d = {}
	for key, value in zip(cfg.z, user_list[0]):
	    d[key] = value

	create_window2(cfg, window, table)

	cfg.mount_point = os.path.expanduser("~/.vnc/sshfs/")
	if (not os.path.exists(cfg.mount_point)):
	    os.makedirs(cfg.mount_point)
	else:
	    umount_point(cfg)
	    cfg.mount_point = os.path.expanduser("~/.vnc/sshfs/")
	
    	cmd = cfg.sshfs+" -o IdentityFile="+d['server_key']+" "+" -p "+d['server_port']+" "+\
    	    d['user']+"@"+d['server']+": "+cfg.mount_point
	proc = popen_sub(cfg, shlex.split(cmd))
	if ( proc == False ):
	    close_window2(None, cfg, window, table)
    	    return

	folder_name = d['user']+"@"+d['server']+":~/"
	vbox = file_browser(cfg, cfg.mount_point, folder_name)

	# button
        closeButton = image_button(cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", close_window2, cfg, window, table)
	closeButton.set_size_request(120, 25)

	frame = gtk.Frame()
	frame2 = gtk.Frame()
        table.attach(frame, 0, 28, 0, 39)
        table.attach(frame2, 0, 28, 39, 42)
	table.attach(vbox, 1, 27, 1, 39)
        table.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

	table.show_all()
	
####################################################################################################

class timersUi:
    def __init__(self, cfg, window, table, treeView, timer_user):
	
	self.cfg = cfg
	self.window = window
	self.treeView = treeView
	self.timer_user = timer_user
	self.table = table
    
    def createUi(self, data=None):
	
	create_window2(self.cfg, self.window, self.table)

	self.treeTimer = gtk.TreeView(self.cfg.timersList)
	self.treeTimer.set_rules_hint(True)
	self.treeTimer.set_enable_tree_lines(True)
	self.treeTimer.connect("button-press-event", self.tree_event)
	TARGETS = [('MY_TREE_MODEL_ROW', gtk.TARGET_SAME_WIDGET, 0), ('TEXT', 0, 0),]
	self.treeTimer.enable_model_drag_source(gtk.gdk.BUTTON1_MASK, TARGETS, gtk.gdk.ACTION_DEFAULT|gtk.gdk.ACTION_MOVE)
	self.treeTimer.enable_model_drag_dest(TARGETS, gtk.gdk.ACTION_DEFAULT)
	self.treeTimer.connect("drag_data_received", self.tree_timer_drag_data_received)

	cell = gtk.CellRendererText()
	column = gtk.TreeViewColumn(_("№"), cell, text=0)
    	column.set_expand(True)
	self.treeTimer.append_column(column)
	
    	cell = gtk.CellRendererPixbuf()
	column = gtk.TreeViewColumn(_("Status"), cell, pixbuf=4)
	column.set_expand(False)
	self.treeTimer.append_column(column)

	cell = gtk.CellRendererText()
	column = gtk.TreeViewColumn(_("Action"), cell, text=1)
    	column.set_expand(True)
	self.treeTimer.append_column(column)

	cell = gtk.CellRendererText()
	column = gtk.TreeViewColumn(_("Time"), cell, text=2)
    	column.set_expand(True)
	self.treeTimer.append_column(column)

	cell = gtk.CellRendererText()
	column = gtk.TreeViewColumn(_("Message")+" / "+_("Command"), cell, text=3)
    	column.set_expand(True)
	self.treeTimer.append_column(column)


	self.treeTimerSelection = self.treeTimer.get_selection()
	self.treeTimerSelection.set_mode(gtk.SELECTION_MULTIPLE)

	swTimer = gtk.ScrolledWindow()
	swTimer.set_shadow_type(gtk.SHADOW_ETCHED_IN)
	swTimer.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	swTimer.add(self.treeTimer)
	
	#######
	# Ui
	#######
	frame = gtk.Frame()

	self.cbAction = gtk.combo_box_new_text()
    	self.cbAction.append_text(_("Logout"))
    	self.cbAction.append_text(_("Reboot"))
    	self.cbAction.append_text(_("Turn On"))
    	self.cbAction.append_text(_("Shutdown"))
    	self.cbAction.append_text(_("Run command"))
    	self.cbAction.append_text(_("Send message"))
    	self.cbAction.set_active(0)
    	
    	# time
    	adj = gtk.Adjustment(0.0, 0.0, 23.0, 1.0, 5.0, 0.0)
    	self.sbHour = gtk.SpinButton(adj, 0, 0)
    	self.sbHour.set_wrap(True)
    	labelHour = gtk.Label(_("Hour"))
    	labelHour.set_alignment(0, 0.5)
	
    	adj = gtk.Adjustment(0.0, 0.0, 59.0, 1.0, 5.0, 0.0)
    	self.sbMin = gtk.SpinButton(adj, 0, 0)
    	self.sbMin.set_wrap(True)
    	labelMin = gtk.Label(_("Minute"))
    	labelMin.set_alignment(0, 0.5)

    	adj = gtk.Adjustment(0.0, 0.0, 59.0, 1.0, 5.0, 0.0)
    	self.sbSec = gtk.SpinButton(adj, 0, 0)
    	self.sbSec.set_wrap(True)
    	labelSec = gtk.Label(_("Second"))
    	labelSec.set_alignment(0, 0.5)
	
	# toolbar
	toolbar = gtk.Toolbar()
	toolbar.set_orientation(gtk.ORIENTATION_HORIZONTAL)
	toolbar.set_style(gtk.TOOLBAR_ICONS)
	toolbar.set_border_width(0)
	toolbar.set_tooltips(True)
	
	button = toolbar_button(self.cfg.pixbuf_list_transfer_16, self.cfg.tooltips, _("Add users"))
	button.connect('clicked',  self.add_client)
	toolbar.insert(button,-1)

	button = toolbar_button(self.cfg.pixbuf_list_remove_16, self.cfg.tooltips, _("Remove"))
	button.connect('clicked',  self.remove_client)
	toolbar.insert(button,-1)

	space = gtk.SeparatorToolItem()
	space.set_draw(False) 
	space.set_expand(gtk.EXPAND)
	toolbar.insert(space,-1)
	
	button = toolbar_button(self.cfg.pixbuf_list_play_16, self.cfg.tooltips, _("Start"))
	button.connect('clicked',  self.timer_start)
	toolbar.insert(button,-1)

	button = toolbar_button(self.cfg.pixbuf_list_stop_16, self.cfg.tooltips, _("Stop"))
	button.connect('clicked',  self.timer_stop)
	toolbar.insert(button,-1)

	toolbar2 = gtk.Toolbar()
	toolbar2.set_orientation(gtk.ORIENTATION_HORIZONTAL)
	toolbar2.set_style(gtk.TOOLBAR_ICONS)
	toolbar2.set_border_width(0)
	toolbar2.set_tooltips(True)
	
	space = gtk.SeparatorToolItem()
	space.set_draw(False) 
	space.set_expand(gtk.EXPAND)
	toolbar2.insert(space,-1)
	
	button = toolbar_button(self.cfg.pixbuf_list_save_16, self.cfg.tooltips, _("Save"))
	button.connect('clicked',  self.save_timer, "save")
	toolbar2.insert(button,-1)

	button = toolbar_button(self.cfg.pixbuf_list_add_16, self.cfg.tooltips, _("New"))
	button.connect('clicked',  self.save_timer, "create")
	toolbar2.insert(button,-1)

	button = toolbar_button(self.cfg.pixbuf_list_remove_16, self.cfg.tooltips, _("Remove"))
	button.connect('clicked',  self.remove_timer)
	toolbar2.insert(button,-1)

	button = toolbar_button(self.cfg.pixbuf_list_edit_16, self.cfg.tooltips, _("Edit"))
	button.connect('clicked',  self.edit_timer)
	toolbar2.insert(button,-1)

	# combobox
	textBox = gtk.ListStore(str)
	self.entryBox = gtk.ComboBoxEntry(textBox, column=0)
	textBox.append([""])
	for i in range(20):
	    if ( self.cfg.read_config("command","f"+str(i+1)) != "" ):
		textBox.append([self.cfg.read_config("command","f"+str(i+1))])
	
	# filechooser
	
        fileChooserButton = image_button(self.cfg.pixbuf_list_file_add_16)
        fileChooserButton.connect("clicked", file_chooser_dialog, self.entryBox, _("Select the file"))

        # button
        closeButton = image_button(self.cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", close_window2, self.cfg, self.window, self.table)
	closeButton.set_size_request(120, 25)

	#
	frame = gtk.Frame()
	frame2 = gtk.Frame()
        self.table.attach(swTimer, 0, 28, 0, 28)
        self.table.attach(toolbar, 0, 28, 28, 30, yoptions=gtk.SHRINK)
        self.table.attach(toolbar2, 0, 28, 37, 39, yoptions=gtk.SHRINK)
	#
        self.table.attach(frame, 0, 28, 30, 37)
        self.table.attach(labelHour, 15, 18, 31, 32, yoptions=gtk.SHRINK)
        self.table.attach(self.sbHour, 15, 18, 32, 34, yoptions=gtk.SHRINK)
        self.table.attach(labelMin, 19, 22, 31, 32, yoptions=gtk.SHRINK)
        self.table.attach(self.sbMin, 19, 22, 32, 34, yoptions=gtk.SHRINK)
        self.table.attach(labelSec, 23, 27, 31, 32, yoptions=gtk.SHRINK)
        self.table.attach(self.sbSec, 23, 26, 32, 34, yoptions=gtk.SHRINK)

        self.table.attach(self.cbAction, 1, 14, 32, 34, yoptions=gtk.SHRINK)

        self.table.attach(self.entryBox, 1, 24, 34, 36, yoptions=gtk.SHRINK)
        self.table.attach(fileChooserButton, 24, 26, 34, 36, yoptions=gtk.SHRINK)
	#
        self.table.attach(frame2, 0, 28, 39, 42)
        self.table.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

	self.table.show_all()
	
    def remove_timer(self, data=None):
        model, rows = self.treeTimerSelection.get_selected_rows()
        if ( rows == [] ):
    	    return
        self.timer_stop()
        tree_iters = []
        for row in rows:
	    if ( len(row) == 1 ):
    	        tree_iters.append(model.get_iter(row))
	for iter in tree_iters:
    	    if ( iter != None ):
		model.remove(iter)
    	save_timersList(self.cfg)

    def remove_client(self, data=None):
	model, rows = self.treeTimerSelection.get_selected_rows()
	tree_iters = []
	for row in rows:
	    if ( len(row) == 1 ):
		continue
    	    tree_iters.append(model.get_iter(row))
    	    timer_path = (row[0],)
    	    # удаление из списка пользователей
    	    user_list = model[timer_path][5]
    	    for x in range(len(user_list)):
    		if ( user_list[x][0] == model[row][1] ):
    		    # Убрать иконки
		    userList_column_value(self.cfg, 54, None, [user_list[x]], False)
    		    del user_list[x]
    		    break
    	    model[timer_path][5] = user_list
    	# удаление
	for iter in tree_iters:
    	    if ( iter != None ):
		model.remove(iter)
    	save_timersList(self.cfg)
    
    def add_client(self, data=None, timer_path=None, user_list=None):
	# drag
	if ( timer_path and user_list ):
	    if ( user_list == [] ):
		return
	    model = self.cfg.timersList
	else:
    	    user_list = get_selected_tree(self.treeView)
	    if ( user_list == [] ):
		return
    	    model, rows = self.treeTimerSelection.get_selected_rows()
    	    if ( rows == [] ):
    		return
	    timer_path = (rows[0][0],)

	timer_iter = model.get_iter(timer_path)
        for z in user_list:
    	    # поиск пользователя, только в этом таймере
    	    for user in model[timer_path][5]:
    		if ( z[0] == user[0] ):
    	    	    return
	    model[timer_path][5].append(z)
    	    model.append(timer_iter, ["",z[0],"","",None,"",0])
    	self.treeTimer.expand_to_path(timer_path)
    	save_timersList(self.cfg)

    def edit_timer(self, data=None):
	self.clear_timer()
    	model, rows = self.treeTimerSelection.get_selected_rows()
    	if ( rows == [] or len(rows[0]) != 1 ):
    	    return
    	number = model[rows[0]][0]
    	action = model[rows[0]][1]
    	time = model[rows[0]][2]
    	command = model[rows[0]][3]

    	(hour,minute,second) = string.split(time, ":")
	if ( action != _("Turn On") and action != _("Logout") and action != _("Reboot") and action != _("Shutdown") ):
    	    self.entryBox.remove_text(0)
	    self.entryBox.insert_text(0,command)
	    self.entryBox.set_active(0)
	    
	model = self.cbAction.get_model()
	for item in range(len(model)):
	    if ( model[item][0] == action ):
		self.cbAction.set_active(item)
		break
	self.sbHour.set_value(int(hour))
    	self.sbMin.set_value(int(minute))
    	self.sbSec.set_value(int(second))
    	self.treeTimer.expand_to_path(rows[0])

    def clear_timer(self, data=None):
        self.sbHour.set_value(0)
        self.sbMin.set_value(0)
        self.sbSec.set_value(0)
        self.entryBox.remove_text(0)
	self.entryBox.insert_text(0,"")
	self.entryBox.set_active(0)
    	self.cbAction.set_active(0)
	
    def save_timer(self, data, mode):
    	model, rows = self.treeTimerSelection.get_selected_rows()
	number = str(len(self.cfg.timersList)+1)
	action = self.cbAction.get_active_text()
	hour = str(int(self.sbHour.get_value()))
	if ( len(hour) == 1 ): hour = "0"+hour
	minute = str(int(self.sbMin.get_value()))
	if ( len(minute) == 1 ): minute = "0"+minute
	second = str(int(self.sbSec.get_value()))
	if ( len(second) == 1 ): second = "0"+second
	start = hour+":"+minute+":"+second
	
	if ( action == _("Logout") or action == _("Reboot") or action == _("Shutdown") ):
	    command = ""
	elif ( action == _("Turn On") ):
	    command = ""
	else:
	    command = self.entryBox.get_active_text()
	    if ( command == "" ):
		return

    	if ( mode == "save" ):
    	    if ( rows == [] or len(rows[0]) != 1 ):
    		return
	    timer_iter = model.get_iter(rows[0])
    	elif ( mode == "create" ):
    	    timer_iter = model.append(None)
    	    model.set(timer_iter, 0, str(number))
    	    model.set(timer_iter, 5, [])

    	model.set(timer_iter, 1, str(action))
    	model.set(timer_iter, 2, str(start))
    	model.set(timer_iter, 3, str(command))
    	if ( mode == "save" ):
    	    if ( model[rows[0]][6] != 0 ):
    		self.timer_stop()
    		self.timer_start()
    	self.clear_timer()
    	save_timersList(self.cfg)
    
    def tree_event(self, treeView, event, data=None):
	mouse_pos = treeView.get_path_at_pos(int(event.x),int(event.y))
	# Снять выделение
	if ( not mouse_pos ):
	    treeView.get_selection().unselect_all()
	    return
	# Действия
        if event.type == gtk.gdk._2BUTTON_PRESS:
	    self.edit_timer()

    def tree_timer_drag_data_received(self, treeview, context, x, y, selection, info, etime):
	# перетаскивание из основного дерева
        if ( not selection.data ):
    	    return
        data = selection.data.splitlines()
	user_list = []
	for z in data:
	    user_list.append(z.split(","))
        drop_info = treeview.get_dest_row_at_pos(x, y)
    	if ( drop_info ):
	    dest_path, dest_position = drop_info
	    if ( len(dest_path) == 2 ):
		dest_path = (dest_path[0],)
	    self.add_client(None, dest_path, user_list)

    def timer_start(self, data=None, num=None):
    	if ( num ):
	    self.timer_user.timer_user("start", int(num)-1)
	else:
    	    model, rows = self.treeTimerSelection.get_selected_rows()
    	    if ( rows == [] ):
    		return
    	    for row in rows:
    		if (len(row) != 1 or model[row][5] == [] or model[row][5] == None ):
    		    continue
		self.timer_user.timer_user("start", row[0])

    def timer_stop(self, data=None, num=None):
    	if ( num ):
	    self.timer_user.timer_user("stop", int(num)-1)
	else:
    	    model, rows = self.treeTimerSelection.get_selected_rows()
    	    if ( rows == [] ):
    		return
    	    for row in rows:
    		if (len(row) != 1):
    		    continue
		self.timer_user.timer_user("stop", row[0])

    def timer_start_all(self, data=None):
	self.timer_user.timer_user("start")

    def timer_stop_all(self, data=None):
	self.timer_user.timer_user("stop")

####################################################################################################

class vncServersUi:
    def __init__(self, cfg, window, table, treeView):
	
	self.cfg = cfg
	self.window = window
	self.treeView = treeView
	self.table = table
	
    def createUi(self, data=None):
	
	create_window2(self.cfg, self.window, self.table)
	
	self.treeVnc = gtk.TreeView(self.cfg.vncList)
	self.treeVnc.set_rules_hint(True)
	self.treeVnc.set_enable_tree_lines(True)
	self.treeVnc.set_headers_visible(True)
	self.treeVnc.set_headers_clickable(False)
	self.treeVnc.modify_font(pango.FontDescription(self.cfg.fontTree))
	self.treeVnc.connect("button-press-event", self.tree_event)

	TARGETS = [('MY_TREE_MODEL_ROW', gtk.TARGET_SAME_WIDGET, 0), ('TEXT', 0, 2),]
	self.treeVnc.enable_model_drag_source(gtk.gdk.BUTTON1_MASK, TARGETS, gtk.gdk.ACTION_DEFAULT|gtk.gdk.ACTION_MOVE)
	self.treeVnc.enable_model_drag_dest(TARGETS, gtk.gdk.ACTION_DEFAULT)
	self.treeVnc.connect("drag_data_received", self.tree_vnc_drag_data_received)
	
	self.treeVncSelection = self.treeVnc.get_selection()
	self.treeVncSelection.set_mode(gtk.SELECTION_MULTIPLE)

	for i in range(60):
	    if ( i == 57 ):
		column = gtk.TreeViewColumn(_("Status"))
		column.set_expand(False)
		column.set_spacing(3)
    		for y in range(3):
    		    cell = gtk.CellRendererPixbuf()
		    column.pack_start(cell, expand=False)
    		    column.set_attributes(cell, pixbuf=int(60)+y)
	    else:
		cell = gtk.CellRendererText()
		if ( i == 0 ):
		    column = gtk.TreeViewColumn(_("Alias"), cell, text=i)
		elif ( i == 1 ):
		    column = gtk.TreeViewColumn(_("User"), cell, text=i)
		elif ( i == 9 ):
		    column = gtk.TreeViewColumn(_("Server"), cell, text=i)
		else:
    		    column = gtk.TreeViewColumn("", cell, text=i)
    		column.set_expand(True)
	    self.treeVnc.append_column(column)

        for i in range(60):
    	    column = self.treeVnc.get_column(i)
    	    if ( i in [0,1,4,57]):
	    	column.set_visible(True)
	    else:
	    	column.set_visible(False)

	swVnc = gtk.ScrolledWindow()
	swVnc.set_shadow_type(gtk.SHADOW_ETCHED_IN)
	swVnc.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	swVnc.add(self.treeVnc)

	# toolbar
	tooltips = self.cfg.tooltips
	toolbarTree = gtk.Toolbar()
	toolbarTree.set_orientation(gtk.ORIENTATION_HORIZONTAL)
	toolbarTree.set_style(gtk.TOOLBAR_ICONS)
	toolbarTree.set_border_width(0)
	toolbarTree.set_tooltips(True)

	# toolbar menu
	button = menu_tool_button(self.cfg.pixbuf_list_transfer_16, self.cfg.tooltips)
	toolbarTree.insert(button,-1)

	item = menu_image_button(self.cfg.pixbuf_list_transfer_16, _("Add the user as a server"))
	item.connect('activate',  self.callback, "add_server")
	button.append(item)

	item = menu_image_button(self.cfg.pixbuf_list_transfer_16, _("Add users as clients"))
	item.connect('activate',  self.callback, "add_client")
	button.append(item)

	button = toolbar_button(self.cfg.pixbuf_list_remove_16, self.cfg.tooltips, _("Remove"))
	button.connect('clicked',  self.callback, "remove")
	toolbarTree.insert(button,-1)

	space = gtk.SeparatorToolItem()
	space.set_draw(False) 
	space.set_expand(gtk.EXPAND)
	toolbarTree.insert(space,-1)

	button = toolbar_button(self.cfg.pixbuf_list_play_16, self.cfg.tooltips, _("Start"))
	button.connect('clicked',  self.callback, "start")
	toolbarTree.insert(button,-1)

	button = toolbar_button(self.cfg.pixbuf_list_stop_16, self.cfg.tooltips, _("Stop"))
	button.connect('clicked',  self.callback, "stop")
	toolbarTree.insert(button,-1)

        # button
        closeButton = image_button(self.cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", close_window2, self.cfg, self.window, self.table)
	closeButton.set_size_request(120, 25)

	#######
	# Ui
	#######
	image = gtk.Image()
	image.set_from_pixbuf(self.cfg.pixbuf_action_vnc_servers)
    	self.table.attach(image, 7, 10, 0, 3, yoptions=gtk.FILL)

	labelVncServers = gtk.Label(_("VNC servers and clients"))
	labelVncServers.set_alignment(0, 0.5)
        self.table.attach(labelVncServers, 10, 27, 0, 3, yoptions=gtk.FILL)

        self.table.attach(swVnc, 0, 28, 3, 37)
        self.table.attach(toolbarTree, 0, 28, 37, 39, yoptions=gtk.SHRINK)
        frame = gtk.Frame()
        self.table.attach(frame, 0, 28, 39, 42)
        self.table.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

	self.table.show_all()

    def add_client(self, server_path=None, user_list=None):
	model = self.cfg.vncList
	# Перетаскивание
	if ( server_path and user_list ):
	    if ( user_list == [] ):
		return
    	    for z in user_list:
    		# поиск в дереве, наличие польз. как сервер или как пользователь
    		check_user = find_tree(self.cfg, model, z[1], z[4])
    		check_server = find_tree(self.cfg, model, "", "", z[0])
    		if ( check_user != False or check_server != False ):
    		    continue
    		server_iter = model.get_iter(server_path)
		iter = model.append(server_iter)
    		for x in range(len(z)):
    		    model.set(iter, int(x), z[int(x)])
	# Добавление кнопкой
    	else:
    	    user_list = get_selected_tree(self.treeView)
	    if ( user_list == [] ):
		return
    	    model, rows = self.treeVncSelection.get_selected_rows()
    	    if ( rows == [] ):
    		return []
    	    server_path = (rows[0][0],)
    	    for z in user_list:
    		# поиск в дереве, наличие польз. как сервер или как пользователь
    		check_user = find_tree(self.cfg, model, z[1], z[4])
    		check_server = find_tree(self.cfg, model, "", "", z[0])
    		if ( check_user != False or check_server != False ):
    		    continue
    		server_iter = model.get_iter(server_path)
		iter = model.append(server_iter)
    		for x in range(len(z)):
    		    model.set(iter, int(x), z[int(x)])
	self.treeVnc.expand_to_path(server_path)
    	save_vncList(self.cfg)

    def add_server(self, user_list=None):
	# Первый из списка добавляется
	# Перетаскивание
	if ( user_list ):
	    if ( user_list == [] ):
		return
    	    z = user_list[0]
	# Добавление кнопкой
    	else:
    	    z = get_selected_tree(self.treeView, "first")
	    if ( z == [] ):
		return
    	    z = z[0]
    	    
    	# поиск в дереве, наличие польз. как сервер или как пользователь
    	check_user = find_tree(self.cfg, self.cfg.vncList, z[1], z[4])
    	check_server = find_tree(self.cfg, self.cfg.vncList, "", "", z[0])
    	if ( check_user != False or check_server != False ):
    	    return

	iter = self.cfg.vncList.append(None)
    	for x in range(50):
    	    self.cfg.vncList.set(iter, int(x), z[int(x)])
	
	# Избыточные данные, для разгрузки функций запуска,остановки
	# если NX, запускать на сервере
	# если тонкий клиент, запускать на клиенте
	# standalone = тонкий клиент
	dn = self.cfg.dn
	if ( self.cfg.vncList.get_value(iter, dn['client']) == "nx" ):
    	    self.cfg.vncList.set(iter, 50, self.cfg.vncList.get_value(iter, dn['user']))
    	    self.cfg.vncList.set(iter, 51, self.cfg.vncList.get_value(iter, dn['server']))
    	    self.cfg.vncList.set(iter, 52, self.cfg.vncList.get_value(iter, dn['server_port']))
    	    self.cfg.vncList.set(iter, 54, self.cfg.vncList.get_value(iter, dn['vnc_server_ssh']))
    	    self.cfg.vncList.set(iter, 55, self.cfg.vncList.get_value(iter, dn['server_key']))
    	else:
    	    self.cfg.vncList.set(iter, 50, self.cfg.vncList.get_value(iter, dn['host_user']))
    	    self.cfg.vncList.set(iter, 51, self.cfg.vncList.get_value(iter, dn['ip']))
    	    self.cfg.vncList.set(iter, 52, self.cfg.vncList.get_value(iter, dn['host_port']))
    	    self.cfg.vncList.set(iter, 54, self.cfg.vncList.get_value(iter, dn['vnc_server_ssh']))
    	    self.cfg.vncList.set(iter, 55, self.cfg.vncList.get_value(iter, dn['host_key']))
    	save_vncList(self.cfg)

    def start(self, data=None):
    	model, rows = self.treeVncSelection.get_selected_rows()
    	if ( rows == [] ):
    	    return
    	for row in rows:
    	    if ( len(row) == 1 ):
    		self.start_server(model, row)
    	    elif ( len(row) == 2 ):
    		self.start_client(model, row)

    def stop(self, data=None):
    	model, rows = self.treeVncSelection.get_selected_rows()
    	if ( rows == [] ):
    	    return
    	for row in rows:
    	    if ( len(row) == 1 ):
    		self.stop_server(model, row)
    	    elif ( len(row) == 2 ):
    		self.stop_client(model, row)

    def remove(self, data=None):
    	model, rows = self.treeVncSelection.get_selected_rows()
    	if ( rows == [] ):
    	    return
	self.stop()
        parent_iters = []
        child_iters = []
	for row in rows:
	    if ( len(row) == 1 and row[0] == 0 ):
		    continue
	    if ( len(row) == 1 ):
    	    	parent_iters.append(model.get_iter(row))
    	    else:
    		child_iters.append(model.get_iter(row))
	for iter in child_iters:
    	    if ( iter != None ):
	        model.remove(iter)
	for iter in parent_iters:
    	    if ( iter != None ):
		model.remove(iter)
    	save_vncList(self.cfg)

    def start_server(self, model, row):
    	# 58 = pid
    	if ( model[row][58] == None or model[row][58] == "" ):
    	    vnc_server = []
    	    for x in range(60):
    		vnc_server.append( str(model[row][x]) )
	    create_vnc_server(self.cfg, vnc_server)

    def stop_server(self, model, row):
    	# 58 = pid
    	if ( model[row][58] != None and model[row][58] != "" ):
    	    vnc_server = []
    	    for x in range(60):
    		vnc_server.append( str(model[row][x]) )
	    stop_vnc_server(self.cfg, vnc_server)

    def start_client(self, model, row):
    	server_path = (row[0],)
    	if ( model[server_path][58] == None or model[server_path][58] == "" ):
    	    return
    	if ( model[row][59] != None and model[row][59] != "" ):
    	    return
    	
	vnc_server = []
    	for x in range(60):
    	    vnc_server.append(model[server_path][x])

	vnc_client = []
    	for x in range(60):
    	    vnc_client.append( str(model[row][x]) )
    	start_vnc_client(self.cfg, vnc_client, vnc_server)

    def stop_client(self, model, row):
    	if ( model[row][59] == None or model[row][59] == "" ):
    	    return
	vnc_client = []
    	for x in range(60):
    	    vnc_client.append( str(model[row][x]) )
    	stop_vnc_client(self.cfg, vnc_client)

    def tree_event(self, treeView, event):
	mouse_pos = treeView.get_path_at_pos(int(event.x),int(event.y))
	# Снять выделение
	if ( not mouse_pos ):
	    treeView.get_selection().unselect_all()
	    return
	#self.treeVnc.expand_all()
	
    def tree_vnc_drag_data_received(self, treeview, context, x, y, selection, info, etime):
	if ( selection.target == "MY_TREE_MODEL_ROW" ):
    	    model, rows = self.treeVncSelection.get_selected_rows()
    	    if ( len(rows[0]) != 1 and ( model[rows[0]][59] == None or model[rows[0]][59] == "" ) ):
    		# Функция для основного списка сойдет
		tree_drag_data_received(treeview, context, x, y, selection, info, etime, self.cfg, "vncList")
	else:
	    # перетаскивание из основного дерева
    	    if ( not selection.data ):
    		return
    	    data = selection.data.splitlines()
	    user_list = []
	    for z in data:
		user_list.append(z.split(","))
    	    drop_info = treeview.get_dest_row_at_pos(x, y)
    	    if ( not drop_info ):
		self.add_server(user_list)
	    else:
		dest_path, dest_position = drop_info
		if ( len(dest_path) == 2 ):
		    dest_path = (dest_path[0],)
		self.add_client(dest_path, user_list)

    def callback(self, data1=None, data2=None, data3=None):
	if ( data2 == "add_server" ):
	    self.add_server()
	if ( data2 == "add_client" ):
	    self.add_client()
	if ( data2 == "remove" ):
	    self.remove()
	if ( data2 == "start" ):
	    thread = thread_gfunc(self.cfg, True, True, self.start)
	    thread.start()
	if ( data2 == "stop" ):
	    thread = thread_gfunc(self.cfg, True, True, self.stop)
	    thread.start()

####################################################################################################

class userUi:

    def __init__(self, cfg, window, table, treeView, mode, user_list=None):
	# create standalone client

	self.table = table
	self.cfg = cfg
	self.window = window
	self.treeView = treeView
	self.mode = mode
	self.mode_edit = False
	self.user_list = user_list
	
	if ( user_list != None ):
	    if ( user_list == [] ):
		return
	    d = {}
	    for value, key in zip(user_list[0], cfg.z):
		d[key] = value
	
	if ( self.mode == "edit" ):
	    if ( d['server'] == "server" ):
		self.mode = "edit_server"
	    elif ( d['server'] == "" or d['server'] == None ):
		self.mode = "edit_group"
	    else:
		self.mode = "client_info"
	
	if ( self.mode == "new_group" ):
	    iter = self.cfg.userList.prepend(None)
	    row = self.cfg.userList.get_path(iter)
	    self.cfg.userList.set(iter, 0, _("New group"))
	    self.cfg.userList.set(iter, 50, self.cfg.pixbuf_status_group_16)
	    col = self.treeView.get_column(0)
	    cell = col.get_cell_renderers()[1]
    	    cell.set_property('editable', True)
	    self.treeView.set_cursor_on_cell(row, col, cell, start_editing=True)
    	    return
    	    
	if ( self.mode == "edit_group" ):
	    model, rows = self.treeView.get_selection().get_selected_rows()
	    row = rows[0]
	    col = self.treeView.get_column(0)
	    cell = col.get_cell_renderers()[1]
    	    cell.set_property('editable', True)
	    self.treeView.set_cursor_on_cell(row, col, cell, start_editing=True)
    	    return
    	    
	self.group = ""
	if ( self.mode == "server" ):
	    labelMode = gtk.Label(_("Add server"))
	    ip = "localhost"
	    vncport = "5900"
	    server_port = "22"
	    server_user = "root"
	    host_port = "22"
	    host_user = "root"
	    dhcp = "static"
	    vnc_pass = ""
	    vnc_pass_file = os.path.expanduser("~/.vnc/passwd")
	    vnc_command = "vncviewer -geometry 1024x768"
	    vnc_client = "vncviewer -fullscreen"
	    self.server = "server"
	    self.group = "server"
	    self.client = "server"
	    over_server = "False"
	    vnc_normal = "True"
	    vnc_ssh = "True"
	    timeout = "100"
	    vnc_server = "x11vnc -noxdamage"
	    server_key = os.path.expanduser("~/.ssh/id_dsa")
	    host_key = os.path.expanduser("~/.ssh/id_dsa")
	    console_server = "mc"
	    console_host = "mc"
	    folder_user = "/Рабочий стол/"
	    vnc_server_ssh = "False"
	    vnc_gtk_color = "Full"
	    vnc_create = "False"
	elif ( self.mode == "edit_server" ):
	    self.mode = "server"
	    self.mode_edit = "server"
	    labelMode = gtk.Label(_("Server information"))
	    ip = d['alias']
	    vncport = d['vncport']
	    server_port = d['server_port']
	    server_user = d['server_user']
	    host_port = d['host_port']
	    host_user = d['host_user']
	    dhcp = d['dhcp']
	    vnc_pass = d['vnc_pass']
	    vnc_pass_file = d['vnc_pass_file']
	    vnc_command = d['vnc_command']
	    vnc_client = d['vnc_client']
	    self.server = d['server']
	    self.group = d['group']
	    self.client = d['client']
	    over_server = d['over_server']
	    vnc_normal = d['vnc_normal']
	    vnc_ssh = d['vnc_ssh']
	    timeout = d['timeout']
	    vnc_server = d['vnc_server']
	    server_key = d['server_key']
	    host_key = d['host_key']
	    console_server = d['console_server']
	    console_host = d['console_host']
	    folder_user = d['folder_user']
	    vnc_server_ssh = d['vnc_server_ssh']
	    vnc_gtk_color = d['vnc_gtk_color']
	    vnc_create = d['vnc_create']
	elif ( self.mode == "standalone" ):
	    labelMode = gtk.Label(_("Add standalone client"))
	    alias = ""
	    user = ""
	    host = ""
	    ip = ""
	    vncport = "5900"
	    display = ":0"
	    mac = ""
	    desktop = "unknown"
	    host_port = "22"
	    dhcp = "static"
	    vnc_pass = ""
	    vnc_pass_file = os.path.expanduser("~/.vnc/passwd")
	    vnc_command = "vncviewer -geometry 1024x768"
	    vnc_client = "vncviewer -fullscreen"
	    self.server = "standalone"
	    self.group = "standalone"
	    self.client = "standalone"
	    over_server = "False"
	    vnc_normal = "True"
	    vnc_ssh = "True"
	    server_key = os.path.expanduser("~/.ssh/id_dsa")
	    host_key = os.path.expanduser("~/.ssh/id_dsa")
	    timeout = "100"
	    vnc_server = "x11vnc -noxdamage"
	    console_host = "mc"
	    folder_user = "/Рабочий стол/"
	    vnc_server_ssh = "False"
	    vnc_gtk_color = "Full"
	    vnc_create = "True"
	elif ( self.mode == "client_info" ):
	    labelMode = gtk.Label(_("Client information"))
	    alias = d['alias']
	    user = d['user']
	    host = d['host']
	    ip = d['ip']
	    vncport = d['vncport']
	    display = d['display']
	    mac = d['mac']
	    desktop = d['desktop']
	    server_port = d['server_port']
	    server_user = d['server_user']
	    host_port = d['host_port']
	    host_user = d['host_user']
	    dhcp = d['dhcp']
	    vnc_pass = d['vnc_pass']
	    vnc_pass_file = d['vnc_pass_file']
	    vnc_command = d['vnc_command']
	    vnc_client = d['vnc_client']
	    over_server = d['over_server']
	    vnc_normal = d['vnc_normal']
	    vnc_ssh = d['vnc_ssh']
	    timeout = d['timeout']
	    self.server = d['server']
	    self.group = d['group']
	    self.client = d['client']
	    vnc_server = d['vnc_server']
	    server_key = d['server_key']
	    host_key = d['host_key']
	    console_server = d['console_server']
	    console_host = d['console_host']
	    folder_user = d['folder_user']
	    vnc_server_ssh = d['vnc_server_ssh']
	    vnc_gtk_color = d['vnc_gtk_color']
	    vnc_create = d['vnc_create']
	    
	create_window2(self.cfg, self.window, self.table)
	
	vbox = gtk.VBox(False, 1)
	layout = gtk.Layout()
	vbox.pack_start(layout, expand=False, fill=False, padding=5)

	if ( self.group == "server" and  self.mode != "server" ):
	    editable = False
	else:
	    editable = True
	
	if ( self.mode != "server" ):
	    self.entryAlias = label_entry(_("Alias"), alias, 24, 24, 20, 210, True)
	    vbox.pack_start(self.entryAlias, expand=False, fill=False, padding=0)

	    self.entryUser = label_entry(_("User"), user, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryUser, expand=False, fill=False, padding=0)

	    self.entryHost = label_entry(_("Host"), host, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryHost, expand=False, fill=False, padding=0)

	self.entryIp = label_entry("IP "+_("address"), ip, 24, 15, 20, 210, editable)
	vbox.pack_start(self.entryIp, expand=False, fill=False, padding=0)
	if ( self.mode == "server" ):
	    self.entryIp.entry.connect("changed", self.callback, "server_changed")
	
	if ( self.mode != "server" ):
	    self.entryMac = label_entry("MAC "+_("address"), mac, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryMac, expand=False, fill=False, padding=0)

	    if ( self.client != "standalone" ):
		self.entryUser.set_editable(False)
		self.entryServer = label_entry(_("Server"), self.server, 24, 24, 20, 210, False)
		vbox.pack_start(self.entryServer, expand=False, fill=False, padding=0)

	    self.entryDisplay = label_entry(_("Display number"), display, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryDisplay, expand=False, fill=False, padding=0)
	
	self.entryTimeout = label_entry(_("Nmap timeout"), timeout, 24, 5, 20, 210, editable)
	vbox.pack_start(self.entryTimeout, expand=False, fill=False, padding=0)
	
	self.entryFolderUser = label_entry(_("Folder for sending files"), folder_user, 24, 100, 20, 210, editable)
	vbox.pack_start(self.entryFolderUser, expand=False, fill=False, padding=0)
	
	if ( self.mode != "server" ):
	    # desktop
	    label = gtk.Label(_("Desktop"))
	    label.set_alignment(0, 0.5)
	    self.comboDesktop = gtk.combo_box_new_text()
	    self.comboDesktop.set_size_request(175, 25)
	    for i in cfg.known_desktop:
    		self.comboDesktop.append_text(i)
    	    fixed = gtk.Fixed()
    	    fixed.put(label, 20, 0)
	    fixed.put(self.comboDesktop, 210, 0)
	    vbox.pack_start(fixed, expand=False, fill=False, padding=0)

	    model = self.comboDesktop.get_model()
	    for item in range(len(model)):
		if ( model[item][0] == desktop or model[item][0] == "unknown" ):
		    self.comboDesktop.set_active(item)
		    break
	    if ( self.group == "server" ):
		self.comboDesktop.set_sensitive(False)
	
	if ( self.client != "standalone" ):
	    # dhcp
	    label = gtk.Label(_("DHCP"))
	    label.set_alignment(0, 0.5)
	    self.comboDhcp = gtk.combo_box_new_text()
	    self.comboDhcp.set_size_request(175, 25)
    	    self.comboDhcp.append_text("dynamic")
    	    self.comboDhcp.append_text("static")
    	    fixed = gtk.Fixed()
    	    fixed.put(label, 20, 0)
	    fixed.put(self.comboDhcp, 210, 0)
	    vbox.pack_start(fixed, expand=False, fill=False, padding=0)

	    model = self.comboDhcp.get_model()
	    for item in range(len(model)):
		if ( model[item][0] == dhcp or model[item][0] == "static" ):
		    self.comboDhcp.set_active(item)
		    break
	    if ( self.group == "server" and self.mode != "server" ):
		self.comboDhcp.set_sensitive(False)

	if ( self.client != "standalone" ):
	    separator = gtk.HSeparator()
	    vbox.pack_start(separator, expand=False, fill=False, padding=0)
	    label = gtk.Label(_("Server"))
	    vbox.pack_start(label, expand=False, fill=False, padding=0)
	    separator = gtk.HSeparator()
	    vbox.pack_start(separator, expand=False, fill=False, padding=0)
	    
	    self.entryServerKey = file_entry(self.cfg.pixbuf_list_file_add_16, "SSH "+_("key"), server_key, 20, 20, 210, editable)
	    self.entryServerKey.button.set_sensitive(editable)
	    vbox.pack_start(self.entryServerKey, expand=False, fill=False, padding=0)

	    self.entryServerPort = label_entry("SSH "+_("port"), server_port, 24, 5, 20, 210, editable)
	    vbox.pack_start(self.entryServerPort, expand=False, fill=False, padding=0)

	    self.entryServerUser = label_entry("SSH "+_("user"), server_user, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryServerUser, expand=False, fill=False, padding=0)

	    self.entryConsoleServer = label_entry("SSH "+_("console"), console_server, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryConsoleServer, expand=False, fill=False, padding=0)

	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)
	label = gtk.Label(_("Host"))
	vbox.pack_start(label, expand=False, fill=False, padding=0)
	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)

	self.entryHostKey = file_entry(self.cfg.pixbuf_list_file_add_16, "SSH "+_("key"), host_key, 20, 20, 210, editable)
	self.entryHostKey.button.set_sensitive(editable)
	vbox.pack_start(self.entryHostKey, expand=False, fill=False, padding=0)

	self.entryHostPort = label_entry("SSH "+_("port"), host_port, 24, 5, 20, 210, editable)
	vbox.pack_start(self.entryHostPort, expand=False, fill=False, padding=0)
	
	if ( self.client != "standalone" ):
	    self.entryHostUser = label_entry("SSH "+_("user"), host_user, 24, 24, 20, 210, editable)
	    vbox.pack_start(self.entryHostUser, expand=False, fill=False, padding=0)
	
	self.entryConsoleHost = label_entry("SSH "+_("console"), console_host, 24, 24, 20, 210, editable)
	vbox.pack_start(self.entryConsoleHost, expand=False, fill=False, padding=0)

	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)
	label = gtk.Label(_("VNC"))
	vbox.pack_start(label, expand=False, fill=False, padding=0)
	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)

	self.entryVncPort = label_entry("VNC "+_("port"), vncport, 24, 5, 20, 210, editable)
	vbox.pack_start(self.entryVncPort, expand=False, fill=False, padding=0)

	self.entryVncCommand = label_entry("VNC "+_("command"), vnc_command, 24, 100, 20, 210, editable)
	vbox.pack_start(self.entryVncCommand, expand=False, fill=False, padding=0)

	self.entryVncPassword = label_entry(_("Password for the built-in client"), vnc_pass, 24, 24, 20, 210, editable, False)
	vbox.pack_start(self.entryVncPassword, expand=False, fill=False, padding=0)

	self.entryVncPasswordFile = file_entry(self.cfg.pixbuf_list_file_add_16, _("Password for the external client"), vnc_pass_file, 20, 20, 210, editable)
	self.entryVncPasswordFile.button.set_sensitive(editable)
	vbox.pack_start(self.entryVncPasswordFile, expand=False, fill=False, padding=0)
	
	###
	label = gtk.Label(_("Color level(built-in)"))
	label.set_alignment(0, 0.5)
	self.comboVncGtkColor = gtk.combo_box_new_text()
	self.comboVncGtkColor.set_size_request(175, 25)
    	self.comboVncGtkColor.append_text("Full")
    	self.comboVncGtkColor.append_text("Medium")
    	self.comboVncGtkColor.append_text("Low")
    	self.comboVncGtkColor.append_text("UltraLow")
    	fixed = gtk.Fixed()
    	fixed.put(label, 20, 0)
	fixed.put(self.comboVncGtkColor, 210, 0)
	vbox.pack_start(fixed, expand=False, fill=False, padding=0)

	model = self.comboVncGtkColor.get_model()
	for item in range(len(model)):
	    if ( model[item][0] == vnc_gtk_color ):
	        self.comboVncGtkColor.set_active(item)
	        break
	self.comboVncGtkColor.set_sensitive(editable)
	
	###
	self.buttonVncCreate = gtk.CheckButton(_("Start the x11vnc server"))
	if ( vnc_create == "True" ):
	    self.buttonVncCreate.set_active(True)
	if ( self.client == "standalone" ):
	    fixed = gtk.Fixed()
	    fixed.put(self.buttonVncCreate, 210, 0)
	    vbox.pack_start(fixed, expand=False, fill=False, padding=0)
	    
	###
        label = gtk.Label(_("Priority of the connection"))

    	self.buttonOverServer = gtk.CheckButton(_("Over server"))
	self.buttonOverServer.set_sensitive(editable)
	if ( over_server == "True" ):
	    self.buttonOverServer.set_active(True)
	if ( self.client != "standalone" ):
	    fixed = gtk.Fixed()
	    fixed.put(self.buttonOverServer, 210, 0)
	    vbox.pack_start(fixed, expand=False, fill=False, padding=0)

	self.buttonVncNormal = gtk.CheckButton(_("VNC normal"))
	self.buttonVncNormal.set_sensitive(editable)
	if ( vnc_normal == "True" ):
	    self.buttonVncNormal.set_active(True)
	fixed = gtk.Fixed()
	fixed.put(label, 20, 0)
	fixed.put(self.buttonVncNormal, 210, 0)
	vbox.pack_start(fixed, expand=False, fill=False, padding=0)
	
        self.buttonVncSsh = gtk.CheckButton(_("VNC over SSH"))
	self.buttonVncSsh.set_sensitive(editable)
	if ( vnc_ssh == "True" ):
	    self.buttonVncSsh.set_active(True)
	fixed = gtk.Fixed()
	fixed.put(self.buttonVncSsh, 210, 0)
	vbox.pack_start(fixed, expand=False, fill=False, padding=0)

	self.buttonVncCreate.connect("clicked", self.callback, "vnc_create")
	self.callback(None,"vnc_create")
	###
	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)
	label = gtk.Label(_("VNC")+" "+_("Server"))
	vbox.pack_start(label, expand=False, fill=False, padding=0)
	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)

	self.entryVncClient = label_entry("VNC "+_("client command"), vnc_client, 24, 100, 20, 210, editable)
	vbox.pack_start(self.entryVncClient, expand=False, fill=False, padding=0)
	
	self.entryVncServer = label_entry("VNC "+_("server command"), vnc_server, 24, 100, 20, 210, editable)
	vbox.pack_start(self.entryVncServer, expand=False, fill=False, padding=0)

	self.buttonVncServerSsh = gtk.CheckButton(_("VNC over SSH"))
	self.buttonVncServerSsh.set_sensitive(editable)
	if ( vnc_server_ssh == "True" ):
	    self.buttonVncServerSsh.set_active(True)
	fixed = gtk.Fixed()
	fixed.put(self.buttonVncServerSsh, 210, 0)
	vbox.pack_start(fixed, expand=False, fill=False, padding=0)
	
	separator = gtk.HSeparator()
	vbox.pack_start(separator, expand=False, fill=False, padding=0)


	layout = gtk.Layout()
	vbox.pack_start(layout, expand=False, fill=False, padding=5)

	# button
        saveButton = image_button(self.cfg.pixbuf_list_save_16, _("Save"))
	saveButton.connect("clicked", self.save)
	saveButton.set_size_request(120, 25)

        closeButton = image_button(self.cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", close_window2, self.cfg, self.window, self.table)
	closeButton.set_size_request(120, 25)
	
	# attach
	frame1 = gtk.Frame()
        table.attach(frame1, 0, 28, 0, 42)

	if ( self.mode == "server" ):
	    image = gtk.Image()
	    image.set_from_pixbuf(cfg.pixbuf_server)
    	    table.attach(image, 6, 9, 0, 3, yoptions=gtk.FILL)
    	elif ( self.mode == "standalone" or self.client == "standalone" ):
	    image = gtk.Image()
	    image.set_from_pixbuf(cfg.pixbuf_st)
    	    table.attach(image, 6, 9, 0, 3, yoptions=gtk.FILL)
	else:
	    image = gtk.Image()
	    image.set_from_pixbuf(cfg.pixbuf_action_user_info)
    	    table.attach(image, 6, 9, 0, 3, yoptions=gtk.FILL)
    	    
	labelMode.set_alignment(0.0,0.5)
        table.attach(labelMode, 10, 27, 0, 3, yoptions=gtk.FILL)
	
	sw = gtk.ScrolledWindow()
	sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
	sw.add_with_viewport(vbox)
    	table.attach(sw, 1, 28, 3, 40, yoptions=gtk.FILL)

        table.attach(saveButton, 1, 7, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        table.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        table.show_all()
        
	if ( self.mode == "server" ):
	    self.callback(None, "server_changed")
	    
    def save(self, data=None):
	
	ip = self.entryIp.get_text()
	if ( self.mode == "server" and (ip in self.cfg.localhost) ):
	    pass
	else:
	    if ( validate("ip", ip ) == False ):
		self.cfg.status(_("Wrong")+" IP "+_("address"))
		return

	host_port = self.entryHostPort.get_text()
	if ( validate("port", host_port ) == False ):
	    self.cfg.status(_("Wrong")+" SSH "+_("Port"))
	    return
	    
	host_key = self.entryHostKey.get_text()
	if ( host_key == ""  ):
	    self.cfg.status(_("Wrong")+" "+_("SSH host key"))
	    return
	    
	timeout = self.entryTimeout.get_text()
	if ( validate("port", timeout ) == False ):
	    self.cfg.status(_("Wrong")+" "+_("Nmap timeout"))
	    return
	    
	vncport = self.entryVncPort.get_text()
	if ( validate("port", vncport ) == False ):
	    self.cfg.status(_("Wrong")+" VNC "+_("Port"))
	    return
	
	if ( self.client != "standalone" ):
	    server_key = self.entryServerKey.get_text()
	    if ( server_key == ""  ):
		self.cfg.status(_("Wrong")+" "+_("SSH server key"))
		return
	    
	    server_user = self.entryServerUser.get_text()
	    if ( validate("username", server_user ) == False ):
		self.cfg.status(_("Wrong")+" SSH "+_("User"))
		return

	    host_user = self.entryHostUser.get_text()
	    if ( validate("username", host_user ) == False ):
		self.cfg.status(_("Wrong")+" SSH "+_("User"))
		return

	    server_port = self.entryServerPort.get_text()
	    if ( validate("port", server_port ) == False ):
		self.cfg.status(_("Wrong")+" SSH "+_("Port"))
		return
	    dhcp = self.comboDhcp.get_active_text()
	
	if ( self.mode != "server" ):
	    alias = self.entryAlias.get_text()
	    if ( alias == ""  ):
		self.cfg.status(_("Wrong")+" "+_("Alias"))
		return
	    user = self.entryUser.get_text()
	    if ( validate("username", user ) == False ):
		self.cfg.status(_("Wrong")+" "+_("User"))
		return
	    mac = self.entryMac.get_text()
	    if ( mac != "" and mac != "0" and validate("mac", mac ) == False ):
		self.cfg.status(_("Wrong")+" MAC "+_("address"))
		return
	    display = self.entryDisplay.get_text()
	    if ( ":" not in display ):
		self.cfg.status(_("Wrong")+" "+_("Display number"))
		return
	    if ( validate("port", display.split(":")[1] ) == False ):
		self.cfg.status(_("Wrong")+" "+_("Display number"))
		return
	    host = self.entryHost.get_text()
	    desktop = self.comboDesktop.get_active_text()

	vnc_gtk_color = self.comboVncGtkColor.get_active_text()
	
	if ( self.mode == "standalone" ):
	    if ( find_tree(self.cfg, self.cfg.userList, user, ip, None) ):
    		self.cfg.status(_("This user already is"))
    		return
	    parent_iter = find_tree(self.cfg, self.cfg.userList, None,None,"standalone")
	    if ( parent_iter == False ):
		parent_iter = self.cfg.userList.prepend(None)
		self.cfg.userList.set(parent_iter, 0, "standalone")
	    iter = self.cfg.userList.append(parent_iter)
    
	elif ( self.mode == "client_info" ):
    	    row = find_tree(self.cfg, self.cfg.userList, user, self.server)
	    if ( row ):
		iter = self.cfg.userList.get_iter(row)
	    else:
    		parent_iter = find_tree(self.cfg, self.cfg.userList, "", "", self.group)
		if ( parent_iter == False ):
		    parent_iter = self.cfg.userList.prepend(None)
		    self.cfg.userList.set(parent_iter, 0, self.group)
		iter = self.cfg.userList.append(parent_iter)
	    
	elif ( self.mode == "server" ):
	    alias = ip
    	    iter = find_tree(self.cfg, self.cfg.userList, "", "", ip)
	    if ( iter ):
		if ( self.mode_edit == "server" ):
		    server_path = self.cfg.userList.get_path(iter)
		    child_iters = []
		    for x in range(self.cfg.userList.iter_n_children(iter)):
			iter_c = self.cfg.userList.get_iter((server_path[0],x))
			child_iters.append(iter_c)
		    for iter_c in child_iters:
			self.cfg.userList.remove(iter_c)
		else:
		    self.cfg.status(_("This server already is"))
		    return
	    else:
		iter = self.cfg.userList.append(None)
	
	dn = self.cfg.dn
	if ( self.group == "server" and self.mode != "server" ):
	    if ( user != alias ):
		self.cfg.userList.set(iter, dn['alias'], alias)
		save_aliasList(self.cfg, user, alias)
	else:
	    self.cfg.userList.set(iter, dn['alias'], alias)
	    self.cfg.userList.set(iter, dn['client'], self.client)
	    self.cfg.userList.set(iter, dn['host_port'], host_port)
	    self.cfg.userList.set(iter, dn['vnc_pass'], self.entryVncPassword.get_text())
	    self.cfg.userList.set(iter, dn['vnc_pass_file'], self.entryVncPasswordFile.get_text())
	    self.cfg.userList.set(iter, dn['vnc_command'], self.entryVncCommand.get_text())
	    self.cfg.userList.set(iter, dn['vnc_client'], self.entryVncClient.get_text())
	    self.cfg.userList.set(iter, dn['vnc_server'], self.entryVncServer.get_text())
	    self.cfg.userList.set(iter, dn['console_host'], self.entryConsoleHost.get_text())
	    self.cfg.userList.set(iter, dn['folder_user'], self.entryFolderUser.get_text())
	    self.cfg.userList.set(iter, dn['vnc_gtk_color'], vnc_gtk_color)

	    if ( self.buttonOverServer.get_active() ):
		self.cfg.userList.set(iter, dn['over_server'], "True")
	    else:
		self.cfg.userList.set(iter, dn['over_server'], "False")
	    if ( self.buttonVncNormal.get_active() ):
		self.cfg.userList.set(iter, dn['vnc_normal'], "True")
	    else:
		self.cfg.userList.set(iter, dn['vnc_normal'], "False")
	    if ( self.buttonVncSsh.get_active() ):
		self.cfg.userList.set(iter, dn['vnc_ssh'], "True")
	    else:
		self.cfg.userList.set(iter, dn['vnc_ssh'], "False")

	    if ( self.buttonVncServerSsh.get_active() ):
		self.cfg.userList.set(iter, dn['vnc_server_ssh'], "True")
	    else:
		self.cfg.userList.set(iter, dn['vnc_server_ssh'], "False")

	    self.cfg.userList.set(iter, dn['timeout'], timeout)
	    self.cfg.userList.set(iter, dn['vncport'], vncport)
	    self.cfg.userList.set(iter, dn['host_key'], host_key)
	    if ( self.client == "standalone" ):
		self.cfg.userList.set(iter, dn['server_key'], host_key)
		self.cfg.userList.set(iter, dn['server_port'], host_port)
		self.cfg.userList.set(iter, dn['server_user'], user)
		self.cfg.userList.set(iter, dn['server'], ip)
		self.cfg.userList.set(iter, dn['host_user'], user)
		self.cfg.userList.set(iter, dn['dhcp'], "static")
		self.cfg.userList.set(iter, dn['console_server'], self.entryConsoleHost.get_text())
		if ( self.buttonVncCreate.get_active() ):
		    self.cfg.userList.set(iter, dn['vnc_create'], "True")
		else:
		    self.cfg.userList.set(iter, dn['vnc_create'], "False")
	    else:
		self.cfg.userList.set(iter, dn['server_key'], server_key)
		self.cfg.userList.set(iter, dn['server_port'], server_port)
		self.cfg.userList.set(iter, dn['server_user'], server_user)
		self.cfg.userList.set(iter, dn['server'], self.server)
		self.cfg.userList.set(iter, dn['host_user'], host_user)
		self.cfg.userList.set(iter, dn['dhcp'], dhcp)
		self.cfg.userList.set(iter, dn['console_server'], self.entryConsoleServer.get_text())
	    if ( self.mode != "server" ):
		self.cfg.userList.set(iter, dn['user'], user)
		self.cfg.userList.set(iter, dn['host'], host)
		self.cfg.userList.set(iter, dn['ip'], ip)
		self.cfg.userList.set(iter, dn['display'], display)
		self.cfg.userList.set(iter, dn['mac'], mac)
		self.cfg.userList.set(iter, dn['desktop'], desktop)
		self.cfg.userList.set(iter, dn['group'], self.group)
	    # Сохранить
	    save_userList(self.cfg)

	# Раскрыть и выделить в дереве позицию
	row = self.cfg.userList.get_path(iter)
    	self.treeView.scroll_to_cell(row, None, use_align=True, row_align=0.5, col_align=0.0)
    	self.treeView.expand_to_path(row)
    	self.treeView.get_selection().unselect_all()
    	self.treeView.get_selection().select_path(row)

    def callback(self, data1=None, data2=None, data3=None):
	if ( data2 == "vnc_create" ):
	    if ( self.buttonVncCreate.get_active() == True ):
    		self.buttonOverServer.set_sensitive(False)
    		self.buttonVncNormal.set_sensitive(False)
    		self.buttonVncSsh.set_sensitive(False)
    		
    		self.buttonOverServer.set_active(False)
    		self.buttonVncNormal.set_active(False)
    		self.buttonVncSsh.set_active(True)
    	    else:
    		self.buttonOverServer.set_sensitive(True)
    		self.buttonVncNormal.set_sensitive(True)
    		self.buttonVncSsh.set_sensitive(True)
    		
	if ( data2 == "server_changed"):
	    if ( self.entryIp.get_text() in self.cfg.localhost ):
		self.entryServerUser.set_editable(False)
		self.buttonOverServer.set_sensitive(False)
	    else:
		self.entryServerUser.set_editable(True)
		self.buttonOverServer.set_sensitive(True)
		
####################################################################################################

class hwinfoUi:

    def __init__(self, cfg, window, table, user_list, mode=None):

	if ( user_list == [] and not mode ):
	    return
	
	self.table = table
	self.cfg = cfg
	self.user_list = user_list
	self.window = window
	
        self.textview = gtk.TextView()
        self.textview.set_editable(False)
        self.textview.set_sensitive(False)
	self.textview.modify_base(gtk.STATE_INSENSITIVE, gtk.gdk.color_parse("white"))

	self.buffer = self.textview.get_buffer()

        self.sw = gtk.ScrolledWindow()
	self.sw.set_policy(gtk.POLICY_ALWAYS, gtk.POLICY_ALWAYS)
        self.sw.add(self.textview)

        closeButton = image_button(self.cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", close_window2, self.cfg, self.window, self.table)
	closeButton.set_size_request(120, 25)

	create_window2(self.cfg, self.window, self.table)

	frame = gtk.Frame()
	frame2 = gtk.Frame()
        table.attach(frame, 0, 28, 0, 39)
	table.attach(self.sw, 1, 28, 1, 39)
        table.attach(frame2, 0, 28, 39, 42)
        table.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

	if ( mode == "log" ):
    	    clearButton = image_button(self.cfg.pixbuf_list_clear_16, _("Clear"))
	    clearButton.connect("clicked", self.clear_log)
	    clearButton.set_size_request(120, 25)
    	    table.attach(clearButton, 1, 7, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
    	    self.log()
        else:
    	    thread_hwinfo = thread_gfunc(self.cfg, True, True, self.hwinfo)
	    thread_hwinfo.start()

	table.show_all()

    def log(self):
	self.textview.connect('size-allocate', self.textview_changed)
    	self.buffer.set_text(self.cfg.read_log())
        self.textview.set_sensitive(True)

    def clear_log(self, data=None):
	self.cfg.clear_log()
	self.buffer.set_text("")
	
    def textview_changed(self, widget, event, data=None):
    	adj = self.sw.get_vadjustment()
    	adj.set_value(adj.upper - adj.page_size)
	    
    def hwinfo(self):
	for line in self.user_list:
	    # проверять по одному, иначе 'over Server' долго
	    z = check_user_list(self.cfg, [line], "ssh")
	    if ( z == [] ):
		continue
	    d = {}
	    for key, value in zip(self.cfg.z, z[0]):
		d[key] = value

	    # NX hosts
	    NX = False
    	    if ( d['client'] == "nx" ):
    	    	host = ""

    	    ssh = self.cfg.ssh_command(d['host_key'], d['host_port'], d['host_user'], d['ip'])
    	    if ( (d['server'] not in self.cfg.localhost) and d['over_server'] == "True" ):
    	    	    # туннель для SSH
	    	    local_port = ssh_tunnel(self.cfg, d['server_key'], d['server_port'], d['server_user'], d['server'], d['ip'], d['host_port'])
	    	    if ( local_port == "0" ): continue
    	    	    ssh = self.cfg.ssh_command(d['host_key'], local_port, d['host_user'], "127.0.0.1")
    		
	    bios = "dmidecode --type bios | grep -E \"BIOS Inf|Vendor|Version|Release\""
	    baseboard = "dmidecode --type baseboard | grep -E \"Board Inf|Manufacturer|Name|Version\""
	    processor = "dmidecode --type processor | grep -E \"Processor Inf|Socket Des|Version|Current\""
	    memory="dmidecode --type memory | grep -E \"Module Inf|Installed Size\""
    	    vga = "lspci -nn | grep VGA | cut -d: -f 3,4"
	    audio = "lspci -nn | grep -E \"audio|Audio\" | cut -d: -f 3,4"
	    ethernet = "lspci -nn | grep Ethernet | cut -d: -f 3,4"
	    #info = popen_os(ssh+" '"+bios+" ; "+baseboard+" ; "+processor+" ; \
	    #	"+memory+" ; echo Video card ; echo -e \"\\t\" \\\"`"+vga+"`\\\" ; echo Sound card ; \
	    #	echo -e \"\\t\" \\\"`"+audio+"`\\\" ; echo Ethernet controller ; echo -e \"\\t\" \\\"`"+ethernet+"`\\\" '").readlines()
	
	    command = bios+" ; "+baseboard+" ; "+processor+" ; \
		"+memory+" ; echo Video card ; echo -e \"\\t\" \\\"`"+vga+"`\\\" ; echo Sound card ; \
		echo -e \"\\t\" \\\"`"+audio+"`\\\" ; echo Ethernet controller ; echo -e \"\\t\" \\\"`"+ethernet+"`\\\"" 
	    cmd = ssh+command
	    proc = popen_sub(self.cfg, cmd.split())
	    if ( proc == False ):
    		info = ""
    	    else:
		info = proc.stdout.readlines()
	    
	    ssh = self.cfg.ssh_command(d['server_key'], d['server_port'], d['user'], d['server'])
	    command = "export DISPLAY="+d['display']+".0; xrandr | grep \\\*"
	    cmd = ssh+command
	    proc = popen_sub(self.cfg, cmd.split())
	    if ( proc == False ):
    		res = ""
    	    else:
    		res = proc.stdout.readline()
    		if ( res != [] ):
		    res = "\t"+res.strip("\n")
		else:
		    res = ""

    	    self.buffer.insert(self.buffer.get_end_iter(), d['alias']+" "+d['ip']+"\n")
	    for line in info:
		line = line.replace('\"', '')
		self.buffer.insert(self.buffer.get_end_iter(), line)
	    self.buffer.insert(self.buffer.get_end_iter(), "Current Resolution\n"+res)
	    self.buffer.insert(self.buffer.get_end_iter(), "\n-----------------------------------------------------------------------------------------\n")
        self.textview.set_sensitive(True)

####################################################################################################

class processUi:

    def __init__(self, cfg, window, table, user_list):

	user_list = check_user_list(cfg, user_list, "empty")
	if ( user_list == [] ):
	    return

	self.cfg = cfg
	self.window = window
	self.table = table
	self.user_list = user_list

	# user,pid,command,mem,start,
	# args,ssh_server_key,ssh_server_port,ssh_server_user,server
	self.process_list = gtk.ListStore(
	    str,str,str,int,str,\
	    str,str,str,str,str)
	tree = gtk.TreeView(self.process_list)
	tree.set_rules_hint(True)
	# parent not show
        create_columns(cfg, tree, ['user', 'pid', 'command', 'mem,Kb', 'start', 'args'], True)

	self.treeSelection = tree.get_selection()
	self.treeSelection.set_mode(gtk.SELECTION_MULTIPLE)

	sw = gtk.ScrolledWindow()
	sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
	sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
	sw.add(tree)

	self.create_process_list()

        refreshButton = image_button(self.cfg.pixbuf_action_refresh_16, _("Refresh"))
	refreshButton.connect("clicked", self.create_process_list)
	refreshButton.set_size_request(120, 25)

        killButton = image_button(self.cfg.pixbuf_list_remove_16, _("Kill"))
	killButton.connect("clicked", self.killProcess)
	killButton.set_size_request(120, 25)

        closeButton = image_button(self.cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", close_window2, self.cfg, self.window, self.table)
	closeButton.set_size_request(120, 25)

	create_window2(self.cfg, self.window, self.table)

	frame = gtk.Frame()
        table.attach(sw, 0, 28, 0, 39)
        table.attach(frame, 0, 28, 39, 42)
        table.attach(refreshButton, 1, 8, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        table.attach(killButton, 9, 16, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        table.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

	table.show_all()

    def create_process_list(self, data=None):
	thread = thread_gfunc(self.cfg, True, True, self.create_process_list_t)
	thread.start()

    def create_process_list_t(self, data=None):

        self.process_list.clear()
    	i = -1
    	sort_list = []
    	users = ""
	server_key = ""
	server_port = ""
	server_user = ""
    	server = ""
    	
    	# сортировка по серверу и отправка сборками
    	self.user_list.sort(key=lambda tup: tup[4])
    	for z in self.user_list:
	    d = {}
	    for key, value in zip(self.cfg.z, z):
		d[key] = value

    	    if ( (server_key != d['server_key'] or server_port != d['server_port'] or\
    		server_user != d['server_user'] or server != d['server']) and\
    		server_key != "" and server_port != "" and server_user != "" and server != "" ):
    		self.ps_os(users[:-1], server_key, server_port, server_user, server)
    		users = ""
	    server_key = d['server_key']
	    server_port = d['server_port']
	    server_user = d['server_user']
    	    server = d['server']
	    users = users+d['user']+","
    	self.ps_os(users[:-1], server_key, server_port, server_user, server)

    def ps_os(self, users, server_key, server_port, server_user, server):
    	if ( server in self.cfg.localhost ):
    	    ssh = ""
    	else:
    	    ssh = self.cfg.ssh_command(server_key, server_port, server_user, server)

	cmd = ssh+self.cfg.ps_command+"-o user,comm,pid,rssize,start_time,args -u "+users+" --sort user,args"
	proc = popen_sub(self.cfg, cmd.split())
	if ( proc == False ):
	    return "0"
	out = proc.stdout.readlines()
	
    	for x in out:
	    if ( "PID" in x ):
		continue
    	    lineParts = string.split(x)
    	    user = lineParts[0]
    	    comm = lineParts[1]
    	    pid = lineParts[2]
    	    rssize = lineParts[3]
    	    start = lineParts[4]
    	    args = lineParts[5]
            self.process_list.append([user, pid, comm, int(rssize), start, args, server_key, server_port, server_user, server])
    
    def killProcess(self, data=None):
        model, rows = self.treeSelection.get_selected_rows()
        if ( rows == [] ):
    	    return
        for row in rows:
    	    user = model[row][0]
    	    pid = model[row][1]
    	    server_key = model[row][6]
    	    server_port = model[row][7]
    	    server_user = model[row][8]
    	    server = model[row][9]
    	    ssh = self.cfg.ssh_command(server_key, server_port, user, server)
    	    cmd = ssh+" kill -9 "+pid+" &"
    	    proc = popen_sub(self.cfg, cmd.split())
	self.create_process_list()

####################################################################################################

class settings:

    def __init__(self, cfg, window, table):

	self.cfg = cfg
	self.window = window
	self.tableSettings = table

	create_window2(self.cfg, self.window, self.tableSettings)

        self.notebookSettings = gtk.Notebook()
        self.notebookSettings.set_tab_pos(gtk.POS_TOP)
        self.tableSettings.attach(self.notebookSettings, 0,28,0,40)
        self.notebookSettings.show()
        self.show_tabs = True
        self.show_border = True

        saveButton = image_button(self.cfg.pixbuf_list_save_16, _("Save"))
	saveButton.connect("clicked", self.callback, "save")
	saveButton.set_size_request(125, 25)
        self.tableSettings.attach(saveButton, 1, 7, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

        closeButton = image_button(self.cfg.pixbuf_action_close_16, _("Close"))
	closeButton.connect("clicked", self.callback, "close")
	closeButton.set_size_request(125, 25)
        self.tableSettings.attach(closeButton, 21, 27, 40, 42, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

        ####################
	# server
        ####################
        self.labelServer = gtk.Label(_("VNC"))
	self.tableServer = gtk.Table(38, 28, True)
        self.notebookSettings.append_page(self.tableServer, self.labelServer)
	
	# NX
        self.labelNX = gtk.Label("NX "+_("Client")+" - "+_("Priority of the connection"))
	self.buttonVncNxHost = gtk.CheckButton(_("Thin client"))
	if ( self.cfg.vncNxHost == "y" ):
	    self.buttonVncNxHost.set_active(True)
        self.buttonVncNxScan = gtk.CheckButton(_("Search VNC port(x11vnc) on server"))
	if ( self.cfg.vncNxScan == "y" ):
	    self.buttonVncNxScan.set_active(True)
	self.buttonVncNxCreate = gtk.CheckButton(_("Start x11vnc and connect"))
	if ( self.cfg.vncNxCreate == "y" ):
	    self.buttonVncNxCreate.set_active(True)
        
	# vncBox
        self.buttonVncBox = gtk.CheckButton(_("Embed VNC in interface"))
	if ( self.cfg.vncGtk == "y" ):
	    self.buttonVncBox.set_active(True)
        self.scaleVncXBox = gtk.HScale()
        self.scaleVncXBox.set_value_pos(gtk.POS_LEFT)
        self.scaleVncXBox.set_digits(0)
        self.scaleVncXBox.set_range(640, 1920)
        self.scaleVncXBox.set_value(float(self.cfg.vncGtkX))
        self.scaleVncXBox.connect("change-value", self.callback, "vncgtkxbox")
        
        self.scaleVncYBox = gtk.HScale()
        self.scaleVncYBox.set_value_pos(gtk.POS_LEFT)
        self.scaleVncYBox.set_digits(0)
        self.scaleVncYBox.set_range(480, 1080)
        self.scaleVncYBox.set_value(float(self.cfg.vncGtkY))
	
        self.labelThumbnails = gtk.Label(_("The size of a thumbnail"))
	self.labelThumbnails.set_alignment(0.0,0.5)
        self.scaleXBox = gtk.HScale()
        self.scaleXBox.set_value_pos(gtk.POS_LEFT)
        self.scaleXBox.set_digits(0)
        self.scaleXBox.set_range(128, 512)
        self.scaleXBox.set_value(float(self.cfg.vncThumbnailsX))
        self.scaleXBox.connect("change-value", self.callback, "xbox")
        
        self.scaleYBox = gtk.HScale()
        self.scaleYBox.set_value_pos(gtk.POS_LEFT)
        self.scaleYBox.set_digits(0)
        self.scaleYBox.set_range(102, 408)
        self.scaleYBox.set_value(float(self.cfg.vncThumbnailsY))
	
        self.labelLocalVncServer = gtk.Label(_("Local")+" VNC "+_("Server"))
	self.labelLocalVncServer.set_alignment(0.5,0.5)

	self.entryVncServer = gtk.Entry()
	self.entryVncServer.set_text( self.cfg.vncServer )
	self.labelVncServer = gtk.Label("VNC "+_("server command"))
	self.labelVncServer.set_alignment(0.0,0.5)

        self.buttonVncServerSsh = gtk.CheckButton(_("VNC over SSH"))
	if ( self.cfg.vncServerSsh == "y" ):
	    self.buttonVncServerSsh.set_active(True)
	#
	# attach
        frame = gtk.Frame()
        self.tableServer.attach(frame, 0, 28, 0, 38)

        frame = gtk.Frame()
        self.tableServer.attach(frame, 1, 27, 1, 10)
        self.tableServer.attach(self.labelNX, 2, 26, 1, 3)
        self.tableServer.attach(self.buttonVncNxHost, 2, 26, 3, 5, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.buttonVncNxScan, 2, 26, 5, 7, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.buttonVncNxCreate, 2, 26, 7, 9, yoptions=gtk.SHRINK)
        
        frame = gtk.Frame()
        self.tableServer.attach(frame, 1, 27, 10, 18)
        self.tableServer.attach(self.buttonVncBox, 2, 26, 11, 13, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.scaleVncXBox, 2, 26, 13, 15, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.scaleVncYBox, 2, 26, 15, 17, yoptions=gtk.SHRINK)

        frame = gtk.Frame()
        self.tableServer.attach(frame, 1, 27, 18, 26)
        self.tableServer.attach(self.labelThumbnails, 2, 26, 19, 21, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.scaleXBox, 2, 26, 21, 23, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.scaleYBox, 2, 26, 23, 25, yoptions=gtk.SHRINK)

        frame = gtk.Frame()
        self.tableServer.attach(frame, 1, 27, 26, 37)
        self.tableServer.attach(self.labelLocalVncServer, 2, 26, 26, 28, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.labelVncServer, 2, 12, 28, 30, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.entryVncServer, 12, 26, 28, 30, yoptions=gtk.SHRINK)
        self.tableServer.attach(self.buttonVncServerSsh, 2, 12, 30, 32, yoptions=gtk.SHRINK)

	###################
	# message
        ###################
        self.labelMessage = gtk.Label(_("Fast messages and commands"))
	self.tableMessage = gtk.Table(38, 28, True)
        self.notebookSettings.append_page(self.tableMessage, self.labelMessage)
        
	vbox = gtk.VBox(False, 1)
	self.entryF1 = gtk.Entry()
	self.entryF1.set_text( self.cfg.f1 )
	vbox.pack_start(self.entryF1, expand=False, fill=False, padding=0)
	self.entryF2 = gtk.Entry()
	self.entryF2.set_text( self.cfg.f2 )
	vbox.pack_start(self.entryF2, expand=False, fill=False, padding=0)
	self.entryF3 = gtk.Entry()
	self.entryF3.set_text( self.cfg.f3 )
	vbox.pack_start(self.entryF3, expand=False, fill=False, padding=0)
	self.entryF4 = gtk.Entry()
	self.entryF4.set_text( self.cfg.f4 )
	vbox.pack_start(self.entryF4, expand=False, fill=False, padding=0)
	self.entryF5 = gtk.Entry()
	self.entryF5.set_text( self.cfg.f5 )
	vbox.pack_start(self.entryF5, expand=False, fill=False, padding=0)
	self.entryF6 = gtk.Entry()
	self.entryF6.set_text( self.cfg.f6 )
	vbox.pack_start(self.entryF6, expand=False, fill=False, padding=0)
	self.entryF7 = gtk.Entry()
	self.entryF7.set_text( self.cfg.f7 )
	vbox.pack_start(self.entryF7, expand=False, fill=False, padding=0)
	self.entryF8 = gtk.Entry()
	self.entryF8.set_text( self.cfg.f8 )
	vbox.pack_start(self.entryF8, expand=False, fill=False, padding=0)
	self.entryF9 = gtk.Entry()
	self.entryF9.set_text( self.cfg.f9 )
	vbox.pack_start(self.entryF9, expand=False, fill=False, padding=0)
	self.entryF10 = gtk.Entry()
	self.entryF10.set_text( self.cfg.f10 )
	vbox.pack_start(self.entryF10, expand=False, fill=False, padding=0)
	self.entryF11 = gtk.Entry()
	self.entryF11.set_text( self.cfg.f11 )
	vbox.pack_start(self.entryF11, expand=False, fill=False, padding=0)
	self.entryF12 = gtk.Entry()
	self.entryF12.set_text( self.cfg.f12 )
	vbox.pack_start(self.entryF12, expand=False, fill=False, padding=0)
	self.entryF13 = gtk.Entry()
	self.entryF13.set_text( self.cfg.f13 )
	vbox.pack_start(self.entryF13, expand=False, fill=False, padding=0)
	self.entryF14 = gtk.Entry()
	self.entryF14.set_text( self.cfg.f14 )
	vbox.pack_start(self.entryF14, expand=False, fill=False, padding=0)
	self.entryF15 = gtk.Entry()
	self.entryF15.set_text( self.cfg.f15 )
	vbox.pack_start(self.entryF15, expand=False, fill=False, padding=0)
	self.entryF16 = gtk.Entry()
	self.entryF16.set_text( self.cfg.f16 )
	vbox.pack_start(self.entryF16, expand=False, fill=False, padding=0)
	self.entryF17 = gtk.Entry()
	self.entryF17.set_text( self.cfg.f17 )
	vbox.pack_start(self.entryF17, expand=False, fill=False, padding=0)
	self.entryF18 = gtk.Entry()
	self.entryF18.set_text( self.cfg.f18 )
	vbox.pack_start(self.entryF18, expand=False, fill=False, padding=0)
	self.entryF19 = gtk.Entry()
	self.entryF19.set_text( self.cfg.f19 )
	vbox.pack_start(self.entryF19, expand=False, fill=False, padding=0)
	self.entryF20 = gtk.Entry()
	self.entryF20.set_text( self.cfg.f20 )
	vbox.pack_start(self.entryF20, expand=False, fill=False, padding=0)
		
        # attach
        frame = gtk.Frame()
        self.tableMessage.attach(frame, 0, 28, 0, 38)

        frame = gtk.Frame()
        self.tableMessage.attach(frame, 1, 27, 1, 37)
        self.tableMessage.attach(vbox, 2, 26, 2, 36, yoptions=gtk.SHRINK)

	###################
	# style
        ###################

        self.labelStyle = gtk.Label(_("Appearance"))
	self.tableStyle = gtk.Table(36, 28, True)
        frame = gtk.Frame()
        self.tableStyle.attach(frame, 0, 28, 0, 38)
        self.notebookSettings.append_page(self.tableStyle, self.labelStyle)
	
        self.labelFontStatus = gtk.Label(_("Font status messages"))
	self.labelFontStatus.set_alignment(0.0,0.5)
	self.buttonFontStatus = gtk.FontButton(self.cfg.fontStatus)
        self.labelFontThumbnails = gtk.Label(_("Font thumbnails"))
	self.labelFontThumbnails.set_alignment(0.0,0.5)
	self.buttonFontThumbnails = gtk.FontButton(self.cfg.fontThumbnails)
        self.labelFontTree = gtk.Label(_("Font list"))
	self.labelFontTree.set_alignment(0.0,0.5)
	self.buttonFontTree = gtk.FontButton(self.cfg.fontTree)
	
        self.labelWindowX = gtk.Label(_("Main window width"))
	self.labelWindowX.set_alignment(0.0,0.5)
    	adj = gtk.Adjustment(0.0, self.cfg.min_mainWindowX, self.cfg.screen_x-self.cfg.min_panedWindowX, 1.0, 5.0, 0.0)
    	self.spinWindowX = gtk.SpinButton(adj, 0, 0)
    	self.spinWindowX.set_wrap(True)
	self.spinWindowX.set_value(int(self.cfg.mainWindowX))
        self.spinWindowX.connect("value-changed", self.callback, "window_x")
	
        self.labelWindowY = gtk.Label(_("Main window height"))
	self.labelWindowY.set_alignment(0.0,0.5)
    	adj = gtk.Adjustment(0.0, self.cfg.min_mainWindowY, self.cfg.screen_y, 1.0, 5.0, 0.0)
    	self.spinWindowY = gtk.SpinButton(adj, 0, 0)
    	self.spinWindowY.set_wrap(True)
	self.spinWindowY.set_value(int(self.cfg.mainWindowY))

        self.labelPanedX = gtk.Label(_("Secondary window width"))
	self.labelPanedX.set_alignment(0.0,0.5)
    	adj = gtk.Adjustment(0.0, self.cfg.min_panedWindowX, self.cfg.max_panedWindowX, 1.0, 5.0, 0.0)
    	self.spinPanedX = gtk.SpinButton(adj, 0, 0)
    	self.spinPanedX.set_wrap(True)
	self.spinPanedX.set_value(int(self.cfg.panedWindowX))
        self.spinPanedX.connect("value-changed", self.callback, "paned_x")

        self.labelTreeX = gtk.Label(_("List width"))
	self.labelTreeX.set_alignment(0.0,0.5)
    	adj = gtk.Adjustment(0.0, self.cfg.min_treeX, self.cfg.max_treeX, 1.0, 5.0, 0.0)
    	self.spinTreeX = gtk.SpinButton(adj, 0, 0)
    	self.spinTreeX.set_wrap(True)
	self.spinTreeX.set_value(int(self.cfg.treeX))
        self.spinTreeX.connect("value-changed", self.callback, "tree_x")

	# tree
        self.frameTree = gtk.Frame(_("List"))

	dn = self.cfg.dn
	self.buttonTreeAlias = gtk.CheckButton(_("Alias"))
	if ( str(dn['alias']) in self.cfg.treeShow ):
	    self.buttonTreeAlias.set_active(True)	
	self.buttonTreeUser = gtk.CheckButton(_("User"))
	if ( str(dn['user']) in self.cfg.treeShow ):
	    self.buttonTreeUser.set_active(True)
	self.buttonTreeHost = gtk.CheckButton(_("Host"))
	if ( str(dn['host']) in self.cfg.treeShow ):
	    self.buttonTreeHost.set_active(True)
	self.buttonTreeIp = gtk.CheckButton(_("IP"))
	if ( str(dn['ip']) in self.cfg.treeShow ):
	    self.buttonTreeIp.set_active(True)
	self.buttonTreeServer = gtk.CheckButton(_("Server"))
	if ( str(dn['server']) in self.cfg.treeShow ):
	    self.buttonTreeServer.set_active(True)
	self.buttonTreeTime = gtk.CheckButton(_("Time"))
	if ( str(dn['start_time']) in self.cfg.treeShow ):
	    self.buttonTreeTime.set_active(True)
	self.buttonTreeMac = gtk.CheckButton(_("MAC"))
	if ( str(dn['mac']) in self.cfg.treeShow ):
	    self.buttonTreeMac.set_active(True)

        self.buttonGecosAlias = gtk.CheckButton(_("Alias")+" = gecos")
	if ( self.cfg.gecosAlias == "y" ):
	    self.buttonGecosAlias.set_active(True)
	
        # attach
        frame = gtk.Frame()
        self.tableStyle.attach(frame, 1, 27, 1, 11)
        self.tableStyle.attach(self.labelWindowX, 2, 20, 2, 4, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.spinWindowX, 20, 26, 2, 4, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.labelWindowY, 2, 20, 4, 6, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.spinWindowY, 20, 26, 4, 6, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.labelPanedX, 2, 20, 6, 8, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.spinPanedX, 20, 26, 6, 8, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.labelTreeX, 2, 20, 8, 10, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.spinTreeX, 20, 26, 8, 10, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

        frame = gtk.Frame()
        self.tableStyle.attach(frame, 1, 27, 11, 19)
        self.tableStyle.attach(self.labelFontStatus, 2, 18, 12, 14, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.buttonFontStatus, 18, 26, 12, 14, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.labelFontThumbnails, 2, 18, 14, 16, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.buttonFontThumbnails, 18, 26, 14, 16, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.labelFontTree, 2, 18, 16, 18, yoptions=gtk.SHRINK)
        self.tableStyle.attach(self.buttonFontTree, 18, 26, 16, 18, xoptions=gtk.SHRINK, yoptions=gtk.SHRINK)

	# tree
        frame = gtk.Frame(_("List"))
        self.tableStyle.attach(frame, 1, 27, 23, 26)
        self.tableStyle.attach(self.buttonGecosAlias, 2, 26, 24, 26, yoptions=gtk.SHRINK)

        frame = gtk.Frame()
        self.tableStyle.attach(frame, 1, 27, 26, 37)
        self.tableStyle.attach(self.buttonTreeAlias, 2, 10, 28, 30)
        self.tableStyle.attach(self.buttonTreeUser, 2, 10, 30, 32)
        self.tableStyle.attach(self.buttonTreeHost, 2, 10, 32, 34)
        self.tableStyle.attach(self.buttonTreeIp, 2, 10, 34, 36)
        self.tableStyle.attach(self.buttonTreeTime, 10, 18, 28, 30)
        self.tableStyle.attach(self.buttonTreeMac, 10, 18, 30, 32)
        self.tableStyle.attach(self.buttonTreeServer, 10, 18, 32, 34)

	##########################################
	
        self.labelOther = gtk.Label(_("Other"))
	self.tableOther = gtk.Table(36, 28, True)
        frame = gtk.Frame()
        self.tableOther.attach(frame, 0, 28, 0, 38)
        self.notebookSettings.append_page(self.tableOther, self.labelOther)
	
        self.buttonLogout = gtk.CheckButton(_("Another command logout"))
	if ( self.cfg.logoutCommandUse == "y" ):
	    self.buttonLogout.set_active(True)
	self.entryLogout = gtk.Entry()
	self.entryLogout.set_text( self.cfg.logoutCommand )

        self.buttonCheckStatus = gtk.CheckButton(_("Check the status of clients (ping), interval"))
	if ( self.cfg.checkStatus == "y" ):
	    self.buttonCheckStatus.set_active(True)
	
	adj = gtk.Adjustment(0.0, 10.0, 60.0, 1.0, 5.0, 0.0)
    	self.spinStatusInterval = gtk.SpinButton(adj, 0, 0)
    	self.spinStatusInterval.set_wrap(True)
	self.spinStatusInterval.set_value(int(self.cfg.checkStatusInterval))

        self.labelVncShotFolder = gtk.Label(_("The screenshot folder"))
	self.labelVncShotFolder.set_alignment(0.0,0.5)
	self.entryVncShotFolder = gtk.Entry()
	self.entryVncShotFolder.set_text( self.cfg.vncShotFolder )
        self.fileChooserShotFolder = image_button(self.cfg.pixbuf_list_folder_add_16)
        self.fileChooserShotFolder.connect("clicked", file_chooser_dialog, self.entryVncShotFolder, _("Select the folder"), None, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)

	self.buttonLtspInfo = gtk.RadioButton(None, "ltspinfo")
	self.buttonLtspSsh = gtk.RadioButton(self.buttonLtspInfo, "ssh")
	if ( self.cfg.ltspInfo == "ssh" ):
	    self.buttonLtspSsh.set_active(True)

        frame = gtk.Frame()
        self.tableOther.attach(frame, 1, 27, 1, 7)
        self.tableOther.attach(self.buttonLogout, 2, 26, 2, 4, yoptions=gtk.SHRINK)
        self.tableOther.attach(self.entryLogout, 2, 26, 4, 6, yoptions=gtk.SHRINK)

        frame = gtk.Frame()
        self.tableOther.attach(frame, 1, 27, 7, 11)
        self.tableOther.attach(self.buttonCheckStatus, 2, 23, 8, 10)
        self.tableOther.attach(self.spinStatusInterval, 23, 26, 8, 10)

        frame = gtk.Frame()
        self.tableOther.attach(frame, 1, 27, 11, 15)
        self.tableOther.attach(self.labelVncShotFolder, 2, 12, 12, 14, yoptions=gtk.SHRINK)
        self.tableOther.attach(self.entryVncShotFolder, 12, 23, 12, 14, yoptions=gtk.SHRINK)
        self.tableOther.attach(self.fileChooserShotFolder, 23, 26, 12, 14, yoptions=gtk.SHRINK)

        frame = gtk.Frame(_("reboot & shutdown"))
        self.tableOther.attach(frame, 1, 14, 31, 37)
        self.tableOther.attach(self.buttonLtspSsh, 2, 11, 32, 34, yoptions=gtk.SHRINK)
        self.tableOther.attach(self.buttonLtspInfo, 2, 11, 34, 36, yoptions=gtk.SHRINK)


	self.tableSettings.show_all()

    def writeAllConfig(self, data=None):
	# NX
	if (self.buttonVncNxHost.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("system","vnc_nx_host", res)

	if (self.buttonVncNxScan.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("system","vnc_nx_scan", res)
	
	if (self.buttonVncNxCreate.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("system","vnc_nx_create", res)

	if (self.buttonVncServerSsh.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("vnc","vnc_server_ssh", res)
    	self.cfg.write_config("vnc","vnc_server", self.entryVncServer.get_text())

	# radio button
	if (self.buttonLtspInfo.get_active()): res="ltspinfo"
	else: res="ssh"
    	self.cfg.write_config("system","ltspinfo", res)

        self.cfg.write_config("command","f1", self.entryF1.get_text())
        self.cfg.write_config("command","f2", self.entryF2.get_text())
        self.cfg.write_config("command","f3", self.entryF3.get_text())
        self.cfg.write_config("command","f4", self.entryF4.get_text())
        self.cfg.write_config("command","f5", self.entryF5.get_text())
        self.cfg.write_config("command","f6", self.entryF6.get_text())
        self.cfg.write_config("command","f7", self.entryF7.get_text())
        self.cfg.write_config("command","f8", self.entryF8.get_text())
        self.cfg.write_config("command","f9", self.entryF9.get_text())
        self.cfg.write_config("command","f10", self.entryF10.get_text())
        self.cfg.write_config("command","f11", self.entryF11.get_text())
        self.cfg.write_config("command","f12", self.entryF12.get_text())
        self.cfg.write_config("command","f13", self.entryF13.get_text())
        self.cfg.write_config("command","f14", self.entryF14.get_text())
        self.cfg.write_config("command","f15", self.entryF15.get_text())
        self.cfg.write_config("command","f16", self.entryF16.get_text())
        self.cfg.write_config("command","f17", self.entryF17.get_text())
        self.cfg.write_config("command","f18", self.entryF18.get_text())
        self.cfg.write_config("command","f19", self.entryF19.get_text())
        self.cfg.write_config("command","f20", self.entryF20.get_text())
	
	# style
	if (self.buttonLogout.get_active()): res="y"
	else: res="n"
        self.cfg.write_config("system","logout_command_use", res)
        self.cfg.write_config("system","logout_command", self.entryLogout.get_text())

        self.cfg.write_config("tree","font_status", self.buttonFontStatus.get_font_name())
        self.cfg.write_config("tree","font_thumbnails", self.buttonFontThumbnails.get_font_name())
        self.cfg.write_config("tree","font_tree", self.buttonFontTree.get_font_name())

	dn = self.cfg.dn
	res = ""
	if (self.buttonTreeAlias.get_active()): res=res+str(dn['alias'])
	if (self.buttonTreeUser.get_active()): res=res+","+str(dn['user'])
	if (self.buttonTreeHost.get_active()): res=res+","+str(dn['host'])
	if (self.buttonTreeIp.get_active()): res=res+","+str(dn['ip'])
	if (self.buttonTreeServer.get_active()): res=res+","+str(dn['server'])
	if (self.buttonTreeTime.get_active()): res=res+","+str(dn['start_time'])
	if (self.buttonTreeMac.get_active()): res=res+","+str(dn['mac'])
    	self.cfg.write_config("tree","tree_show", res)

	window_x = int(self.spinWindowX.get_value())
	paned_x = int(self.spinPanedX.get_value())
	if ( self.cfg.screen_x < window_x+paned_x ):
	    paned_x = self.cfg.min_panedWindowX
	    window_x = self.cfg.screen_x - self.cfg.min_panedWindowX
	self.cfg.write_config("window","main_window_x", str(window_x))
	self.cfg.write_config("window","main_window_y", str(int(self.spinWindowY.get_value())))
	self.cfg.write_config("window","paned_window_x", str(paned_x))
	self.cfg.write_config("window","tree_x", str(int(self.spinTreeX.get_value())))

	if (self.buttonCheckStatus.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("tree","check_status", res)
        self.cfg.write_config("tree","check_status_interval", str(int(self.spinStatusInterval.get_value())))
	
	if (self.buttonGecosAlias.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("tree","gecos_alias", res)

	if (self.buttonVncBox.get_active()): res="y"
	else: res="n"
    	self.cfg.write_config("vnc","vnc_gtk", res)
        self.cfg.write_config("vnc","vnc_gtk_x", str(int(self.scaleVncXBox.get_value())))
        self.cfg.write_config("vnc","vnc_gtk_y", str(int(self.scaleVncYBox.get_value())))

        self.cfg.write_config("vnc","vnc_thumbnails_x", str(int(self.scaleXBox.get_value())))
        self.cfg.write_config("vnc","vnc_thumbnails_y", str(int(self.scaleYBox.get_value())))

        self.cfg.write_config("vnc","vnc_shot_folder", self.entryVncShotFolder.get_text())


    def callback(self, widget, data1=None ,data2=None, data3=None):
	if ( data1 == "save" ):
	    self.writeAllConfig()
	    self.cfg.read()
	    close_window2(None, self.cfg, self.window, self.tableSettings)

	if ( data1 == "close" ):
	    close_window2(None, self.cfg, self.window, self.tableSettings)
	
	if (data1 == "window_x" ):
	    window_x = self.spinWindowX.get_value()
	    if ( self.spinPanedX.get_value() > self.cfg.screen_x-window_x ):
		self.spinPanedX.set_value(self.cfg.screen_x-window_x)

	if (data1 == "paned_x" ):
	    paned_x = self.spinPanedX.get_value()
	    if ( self.spinWindowX.get_value() > self.cfg.screen_x-paned_x ):
		self.spinWindowX.set_value(self.cfg.screen_x-paned_x)

	# Соотношение сторон, но только Y координата зависит от X
	if (data3 == "vncgtkxbox" ):
	    self.scaleVncYBox.set_value(data2/1.33)
	if (data3 == "xbox" ):
	    self.scaleYBox.set_value(data2/1.25)
	
